package edu.uoc.android.gfp.modeloDatos;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_Cuenta_Bancaria {

    public static final List<Cuenta_Bancaria> CUENTAS_BANCARIAS = new ArrayList<>();

    //Procedimiento para obtener el total de Deseos en la BD local asociados al usuario
    //que ha hecho Login
    public static List<Cuenta_Bancaria> obtenerTodasCuentasBancarias(String idUsuario) {

        List<Cuenta_Bancaria> Deseos = Cuenta_Bancaria.find(Cuenta_Bancaria.class, "id_Usuario = ?", idUsuario);
        return Deseos;

    }

    //Procedimiento para comprobar si Deseo ya existe en la BD local
    public static boolean existe(Cuenta_Bancaria tCuenta_Bancaria) {

        List<Cuenta_Bancaria> mcuentaBancaria = Cuenta_Bancaria.find(Cuenta_Bancaria.class, "id_Cuenta = ?", tCuenta_Bancaria.getIdCuenta().toString());

        if (mcuentaBancaria == null || mcuentaBancaria.size() == 0) {
            return false;
        } else {
            return true;
        }

    }

    //Procedimiento para obtener el último idDeseo
    public static Integer ultimoIdDeseo() {

        List<Cuenta_Bancaria> ultimaCuenta_Bancaria = Select.from(Cuenta_Bancaria.class)
                .orderBy("id_Cuenta")
                .list();

        if (ultimaCuenta_Bancaria.size() > 0)
            return ultimaCuenta_Bancaria.get(0).getIdCuenta();
        else
            return 0;

    }

    public static Cuenta_Bancaria leerDeseo(Integer idDeseo,String idUsuario){

        List<Cuenta_Bancaria> mDeseos = Select.from(Cuenta_Bancaria.class)
                .where(Condition.prop("id_Usuario").eq(idUsuario),
                        Condition.prop("id_Deseo").eq(idDeseo))
                .list();


        return mDeseos.get(0);

    }





    public static class Cuenta_Bancaria extends  SugarRecord {

        public Integer idCuenta;
        public String descripcion;
        public String numeroCuenta;
        public String idUsuario;

        public Cuenta_Bancaria() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Cuenta_Bancaria(Integer idCuenta, String descripcion,String numeroCuenta,String idUsuario) {
            this.idCuenta = idCuenta;
            this.descripcion = descripcion;
            this.numeroCuenta=numeroCuenta;
            this.idUsuario=idUsuario;
        }


        public Integer getIdCuenta() {
            return idCuenta;
        }

        public void setIdCuenta(Integer idCuenta) {
            this.idCuenta = idCuenta;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public String getnumeroCuenta() {
            return numeroCuenta;
        }

        public void setnumeroCuenta(String numeroCuenta) {
            this.numeroCuenta = numeroCuenta;
        }

        public String getidUsuario() {
            return idUsuario;
        }

        public void setidUsuario(String idUsuario) {
            this.idUsuario = idUsuario;
        }

        @Override
        public String toString() {

            return "Cuenta_Bancaria {" +
                    "idCuenta=" + idCuenta +
                    "descripcion='" + descripcion + '\'' +
                    "numeroCuenta=" + numeroCuenta +
                    "idUsuario='" + idUsuario + '\'' +
                    '}';
        }



    }







}