package edu.uoc.android.gfp.modeloDatos;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_Situacion {

    public static final List<Situacion> SITUACIONES = new ArrayList<>();

    //Procedimiento para obtener el total de SITUACIONES en la BD local asociados al usuario
    //que ha hecho Login
    public static List<Situacion> obtenerTodasSituacion(String idUsuario) {

        List<Situacion> Situaciones = Situacion.find(Situacion.class, "id_Usuario = ?", idUsuario);
        return Situaciones;

    }

    //Procedimiento para comprobar si Gasto ya existe en la BD local
    public static boolean existe(Situacion tSituacion) {

        List<Situacion> Situacion = T_Situacion.Situacion.find(Situacion.class, "descripcion = ?", tSituacion.descripcion);

        if (Situacion == null || Situacion.size() == 0) {
            return false;
        } else {
            return true;
        }

    }

    //Procedimiento para obtener el último idTipoGasto
    public static Integer ultimoIdSituacion() {

        List<Situacion> ultimoSituacion = Select.from(Situacion.class)
                .orderBy("id_Situacion")
                .list();

        if (ultimoSituacion.size() > 0)
            return ultimoSituacion.get(0).getIdSituacion();
        else
            return 0;

    }

    public static Situacion leerSituacion(Integer idSituacion,String idUsuario){

        List<Situacion> mSituacions = Select.from(Situacion.class)
                .where(Condition.prop("id_Usuario").eq(idUsuario),
                        Condition.prop("id_Situacion").eq(idSituacion))
                .list();


        return mSituacions.get(0);

    }

    public static class Situacion extends SugarRecord{

        public Integer idSituacion;
        public String descripcion;
        public float relacionGastoIngreso;
        public String idUsuario;


        public Situacion() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Situacion(Integer idSituacion,String descripcion,float relacionGastoIngreso,String idUsuario) {

            this.idSituacion=idSituacion;
            this.descripcion=descripcion;
            this.relacionGastoIngreso=relacionGastoIngreso;
            this.idUsuario=idUsuario;

        }

        public Integer getIdSituacion() {
            return idSituacion;
        }

        public void setIdSituacion(Integer idSituacion) {
            this.idSituacion = idSituacion;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public float getrelacionGastoIngreso() {
            return relacionGastoIngreso;
        }

        public void setrelacionGastoIngreso(float relacionGastoIngreso) {
            this.relacionGastoIngreso = relacionGastoIngreso;
        }

        public String getidUsuario() {
            return idUsuario;
        }

        public void setidUsuario(String idUsuario) {
            this.idUsuario = idUsuario;
        }

        @Override
        public String toString() {

            return "Situacion {" +
                    "idSituacion=" + idSituacion +
                    "descripcion='" + descripcion + '\'' +
                    "relacionGastoIngreso=" + relacionGastoIngreso +
                    "idUsuario='" + idUsuario + '\'' +
                    '}';
        }

    }



    }


