package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.support.annotation.RequiresApi;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_Usuario {

         public static final List<Usuario> L_USUARIOS = new ArrayList<>();

        //Procedimiento para obtener el total de USUARIOS en la BD local
        public static List<Usuario> obtenerTodosUsuarios(){

            return Usuario.listAll(Usuario.class);

        }

        //Procedimiento para comprobar si un USUARIO ya existe en la BD local
        public static boolean existe(Usuario tUsuario) {

            List<Usuario> mUsuario = Usuario.find(Usuario.class, "id_Usuario = ?", tUsuario.idUsuario);

            if (mUsuario == null || mUsuario.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idUsuario
    public static Integer ultimoidUsuario ()
    {

        List<Usuario> ultimoUsuario = Select.from(Usuario.class)
                .orderBy("cod_Usuario")
                .list();

        if (ultimoUsuario.size()>0)
            return ultimoUsuario.get(0).getCodUsuario();
        else
            return 0;

    }


    public static Boolean validarUsuarioBD (String idUsuario,String pwd){

        List<Usuario> musuarios = Select.from(Usuario.class)
                .where(Condition.prop("id_Usuario").eq(idUsuario),
                        Condition.prop("pwd").eq(pwd))
                .list();


        if (musuarios.size()>0)
            return  true;
        else
            return  false;

    }

    public static T_Usuario.Usuario leerUsuario(Integer codUsuario, String idUsuario){

        List<T_Usuario.Usuario> mUsuarios = Select.from(T_Usuario.Usuario.class)
                .where(Condition.prop("id_Usuario").eq(idUsuario))
                .list();


        return mUsuarios.get(0);

    }


    public static void eliminarUsuario(Context contexto, Integer codUSuario){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        SQLiteStatement query = db.compileStatement("delete from usuario where cod_usuario=" + codUSuario);
        query.execute();
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    public static Integer altaUsuario(Context contexto, String idUsuario,String pwd,String nombreCompleto,String email,Integer idAlimentacion,String alimentacion,String notificarEmail){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long codUsuario;


        ContentValues contentValues = new ContentValues();
        contentValues.put("id_Usuario", idUsuario);
        contentValues.put("pwd", pwd);
        contentValues.put("nombre_completo", nombreCompleto);
        contentValues.put("email", email);
        contentValues.put("id_alimentacion", idAlimentacion);
        contentValues.put("alimentacion", alimentacion);
        contentValues.put("notificar_email", notificarEmail);


        codUsuario=db.insert("Usuario","idUsuario, pwd, nombreCompleto, email, idAlimentacion, alimentacion, notificarEmail",contentValues);

        SQLiteStatement query = db.compileStatement("update usuario set cod_usuario=" + codUsuario + " where id=" + codUsuario);
        query.execute();

        return Math.toIntExact(codUsuario);

    }

    public static void modificaUsuario (Context contexto,Integer codUsuario,String idUsuario,String pwd,String nombreCompleto,String email,Integer idAlimentacion,String alimentacion,String notificarEmail ){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        ContentValues contentValues = new ContentValues();
        contentValues.put("id_Usuario", idUsuario);
        contentValues.put("pwd", pwd);
        contentValues.put("nombre_completo", nombreCompleto);
        contentValues.put("email", email);
        contentValues.put("id_alimentacion", idAlimentacion);
        contentValues.put("alimentacion", alimentacion);
        contentValues.put("notificar_email", notificarEmail);

        db.update("Usuario",contentValues,"cod_usuario = ? ", new String[]{codUsuario.toString()});

    }



    public static class Usuario extends  SugarRecord{

        public Integer codUsuario;
        public String idUsuario;
        public String pwd;
        public String nombreCompleto;
        public String email;
        public Integer idAlimentacion;
        //Se añade para evitar hacer vistas en FB
        public String alimentacion;
        public String notificarEmail;


        public Usuario(Integer codUsuario,String idUsuario,String pwd,String nombreCompleto,String email,Integer idAlimentacion,String alimentacion,String notificarEmail) {

            this.codUsuario=codUsuario;
            this.idUsuario=idUsuario;
            this.pwd=pwd;
            this.nombreCompleto=nombreCompleto;
            this.email=email;
            this.idAlimentacion=idAlimentacion;
            this.alimentacion=alimentacion;
            this.notificarEmail=notificarEmail;
        }

        public Usuario() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Integer getCodUsuario() {
            return codUsuario;
        }

        public void setCodUsuario(Integer codUsuario) {
            this.codUsuario = codUsuario;
        }

        public String getidUsuario() {
            return idUsuario;
        }

        public void setidUsuario(String idUsuario) {
            this.idUsuario = idUsuario;
        }

        public String getpwd() {
            return pwd;
        }

        public void setpwd(String pwd) {
            this.pwd = pwd;
        }

        public void setnombreCompleto(String nombreCompleto) {
            this.nombreCompleto = nombreCompleto;
        }

        public String getnombreCompleto() {
            return nombreCompleto;
        }

        public void setemail(String email) {
            this.email = email;
        }

        public String getemail() {
            return email;
        }

        public Integer getidAlimentacion() {
            return idAlimentacion;
        }

        public void setidAlimentacion(Integer idAlimentacion) {
            this.idAlimentacion = idAlimentacion;
        }

        public void setalimentacion(String alimentacion) {
            this.alimentacion = alimentacion;
        }

        public String getalimentacion() {
            return alimentacion;
        }

        public void setNotificarEmail(String notificarEmail) {
            this.notificarEmail = notificarEmail;
        }

        public String getNotificarEmail() {
            return notificarEmail;
        }

        @Override
        public String toString() {

            return "Usuario{" +
                    "codUsuario='" + codUsuario  +
                    ", idUsuario=" + idUsuario + '\'' +
                    ", pwd=" + pwd + '\'' +
                    ", nombreCompleto=" + nombreCompleto + '\'' +
                    ", email=" + email + '\'' +
                    ", idAlimentacion='" + idAlimentacion  +
                    '}';
        }

    }



}
