package edu.uoc.android.gfp.modeloDatos;

import com.orm.SugarRecord;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_tipo_Alimentacion {

         public static final List<Tipo_Alimentacion> TIPOS_ALIMENTACION = new ArrayList<>();

        //Procedimiento para obtener el total de tipos de gastos en la BD local
        public static List<Tipo_Alimentacion> obtenerTodosTiposAlimentacion(){

            return Tipo_Alimentacion.listAll(Tipo_Alimentacion.class);

        }

        //Procedimiento para comprobar si un Tipo de Alimentacion ya existe en la BD local
        public static boolean existe(Tipo_Alimentacion tAlimentacion) {

            List<Tipo_Alimentacion> mAlimentacion = Tipo_Alimentacion.find(Tipo_Alimentacion.class, "id_Alimentacion = ?", tAlimentacion.getidAlimentacion().toString());

            if (mAlimentacion == null || mAlimentacion.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idTipoGasto
    public static Integer ultimoIdAlimentacion ()
    {

        List<Tipo_Alimentacion> ultimoAlimentacion = Select.from(Tipo_Alimentacion.class)
                .orderBy("id_Alimentacion")
                .list();

        if (ultimoAlimentacion.size()>0)
            return ultimoAlimentacion.get(0).getidAlimentacion();
        else
            return 0;

    }




    public static class Tipo_Alimentacion  extends SugarRecord {

        public Integer idAlimentacion;
        public String descripcion;

        public Tipo_Alimentacion() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Tipo_Alimentacion(Integer idAlimentacion, String descripcion) {
            this.idAlimentacion = idAlimentacion;
            this.descripcion = descripcion;
        }


        public Integer getidAlimentacion() {
            return idAlimentacion;
        }

        public void setidAlimentacion(Integer idAlimentacion) {
            this.idAlimentacion = idAlimentacion;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }




        @Override
        public String toString() {

            return "Tipo_Alimentacion {" +
                    "idAlimentacion='" + idAlimentacion  +
                    ", descripcion=" + descripcion + '\'' +
                    '}';
        }
    }



}
