package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.support.annotation.RequiresApi;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public class T_tipo_Gasto {

         public static final List<Tipo_Gasto> TIPOS_GASTOS = new ArrayList<>();

        //Procedimiento para obtener el total de tipos de gastos en la BD local
        public static List<Tipo_Gasto> obtenerTodosTiposGasto(){

            return Tipo_Gasto.listAll(Tipo_Gasto.class);

        }

        //Procedimiento para comprobar si un Tipo de Gasto ya existe en la BD local
        public static boolean existe(Tipo_Gasto tgasto) {

            List<Tipo_Gasto> tgasto1 = Tipo_Gasto.find(Tipo_Gasto.class, "descripcion = ?", tgasto.descripcion);

            if (tgasto1 == null || tgasto1.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idTipoGasto
    public static Integer ultimoIdTipoGasto ()
    {

        List<Tipo_Gasto> ultimoGasto = Select.from(Tipo_Gasto.class)
                .orderBy("id_Tipo_Gasto")
                .list();

        if (ultimoGasto.size()>0)
            return ultimoGasto.get(0).getidTipoGasto();
        else
            return 0;

    }

    public static T_tipo_Gasto.Tipo_Gasto leerTipoGasto(Integer idTipoGasto){

        List<T_tipo_Gasto.Tipo_Gasto> mtiposgastos = Select.from(T_tipo_Gasto.Tipo_Gasto.class)
                .where(Condition.prop("id_tipo_gasto").eq(idTipoGasto))
                .list();
        return mtiposgastos.get(0);

    }

    public static void eliminarTipoGasto(Context contexto, Integer idTipoGasto){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        SQLiteStatement query = db.compileStatement("delete from tipogasto where id_tipo_gasto=" + idTipoGasto);
        query.execute();
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    public static Integer altaTipoGasto(Context contexto, String descripcion,Integer idNecesidad,String necesidad){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long idTipoGasto;


        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);
        contentValues.put("id_Necesidad", idNecesidad);
        contentValues.put("necesidad", necesidad);

        idTipoGasto=db.insert("Tipogasto","descripcion,id_necesidad,necesidad",contentValues);

        SQLiteStatement query = db.compileStatement("update tipogasto set id_tipo_gasto=" + idTipoGasto + " where id=" + idTipoGasto);
        query.execute();

        return Math.toIntExact(idTipoGasto);

    }

    public static void modificaTipoGasto (Context contexto,Integer idTipoGasto,String descripcion,Integer idNecesidad,String necesidad ){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);
        contentValues.put("id_necesidad", idNecesidad);
        contentValues.put("necesidad", necesidad);

        db.update("tipogasto",contentValues,"id_tipo_gasto = ? ", new String[]{idTipoGasto.toString()});

    }


    public static List<T_tipo_Gasto.Tipo_Gasto> obtenerDetalleTiposGastos (Context contexto)
    {

        String consulta;
        List<T_tipo_Gasto.Tipo_Gasto> mtiposgastos= new ArrayList<>();
        T_tipo_Gasto.Tipo_Gasto gasto;


        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);


        consulta=" select * from tipogasto ";

        Cursor c = db.rawQuery(consulta,null);

        c.moveToFirst();

        while (!c.isAfterLast())
        {
            //0 ID INTEGER PRIMARY KEY AUTOINCREMENT ,
            // 1 DESCRIPCION_COMPARATOR ,
            // 2 DESCRIPCION TEXT,
            // 3 ID_NECESIDAD INTEGER,
            // 4 ID_TIPO_GASTO INTEGER

            gasto = new T_tipo_Gasto.Tipo_Gasto();
            gasto.idTipoGasto=Integer.parseInt(c.getString(4));
            gasto.descripcion=c.getString(2);
            gasto.idNecesidad=Integer.parseInt(c.getString(3));
            gasto.necesidad=c.getString(5);


            mtiposgastos.add(gasto); //add the item
            c.moveToNext();
        }


        return mtiposgastos;
    }



    public static class Tipo_Gasto extends SugarRecord {

        public Integer idTipoGasto;
        public String descripcion;
        public Integer idNecesidad;
        public String necesidad;

        public Tipo_Gasto () {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Tipo_Gasto (Integer idTipoGasto, String descripcion,Integer idNecesidad,String necesidad)
        {
            this.idTipoGasto = idTipoGasto;
            this.descripcion = descripcion;
            this.idNecesidad=idNecesidad;
            this.necesidad=necesidad;
        }





        public Integer getidTipoGasto() {
            return idTipoGasto;
        }

        public void setidTipoGasto(Integer idTipoGasto) {
            this.idTipoGasto = idTipoGasto;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public Integer getidNecesidad() {
            return idNecesidad;
        }

        public void setidNecesidad(Integer idNecesidad) {
            this.idNecesidad = idNecesidad;
        }

        public String getNecesidad() {
            return necesidad;
        }

        public void setnecesidad(String necesidad) {
            this.necesidad = necesidad;
        }

        @Override
        public String toString() {

            return "Tipo_Gasto {" +
                    "idTipoGasto='" + idTipoGasto  +
                    ", descripcion=" + descripcion + '\'' +
                    ", idNecesidad='" + idNecesidad  +
                    ", necesidad=" + necesidad + '\'' +
                    '}';
        }

        public Comparator<Tipo_Gasto> DescripcionComparator = new Comparator<Tipo_Gasto>() {
            public int compare(Tipo_Gasto gasto1, Tipo_Gasto gasto2) {
                return gasto1.descripcion.toUpperCase().compareTo(gasto2.descripcion.toUpperCase());
            }
        };



    }



}
