package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.support.annotation.RequiresApi;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public class T_tipo_Ingreso {

         public static final List<Tipo_Ingreso> TIPOS_INGRESOS = new ArrayList<>();

        //Procedimiento para obtener el total de tipos de gastos en la BD local
        public static List<Tipo_Ingreso> obtenerTodosTiposIngresos(){

            return Tipo_Ingreso.listAll(Tipo_Ingreso.class);

        }

        //Procedimiento para comprobar si un Tipo de Gasto ya existe en la BD local
        public static boolean existe(Tipo_Ingreso tIngreso) {

            List<Tipo_Ingreso> mingreso = Tipo_Ingreso.find(Tipo_Ingreso.class, "id_Tipo_Ingreso = ?", tIngreso.getidTipoIngreso().toString());

            if (mingreso == null || mingreso.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idTipoGasto
    public static Integer ultimoIdTipoIngreso ()
    {

        List<Tipo_Ingreso> ultimoIngreso = Select.from(Tipo_Ingreso.class)
                .orderBy("id_Tipo_Ingreso")
                .list();

        if (ultimoIngreso.size()>0)
            return ultimoIngreso.get(0).getidTipoIngreso();
        else
            return 0;

    }

    public static T_tipo_Ingreso.Tipo_Ingreso leerTipoIngreso(Integer idTipoIngreso){

        List<T_tipo_Ingreso.Tipo_Ingreso> mtiposingresos = Select.from(T_tipo_Ingreso.Tipo_Ingreso.class)
                .where(Condition.prop("id_tipo_ingreso").eq(idTipoIngreso))
                .list();
        return mtiposingresos.get(0);

    }

    public static void eliminarTipoIngreso(Context contexto, Integer idTipoIngreso){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        SQLiteStatement query = db.compileStatement("delete from tipoingreso where id_tipo_ingreso=" + idTipoIngreso);
        query.execute();
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    public static Integer altaTipoIngreso(Context contexto, String descripcion){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long idTipoIngreso;


        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);


        idTipoIngreso=db.insert("tipoingreso","descripcion",contentValues);

        SQLiteStatement query = db.compileStatement("update tipoingreso set id_tipo_ingreso=" + idTipoIngreso + " where id=" + idTipoIngreso);
        query.execute();

        return Math.toIntExact(idTipoIngreso);

    }

    public static void modificaTipoIngreso (Context contexto,Integer idTipoIngreso,String descripcion ){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);

        db.update("tipoingreso",contentValues,"id_tipo_ingreso = ? ", new String[]{idTipoIngreso.toString()});

    }





    public static List<T_tipo_Ingreso.Tipo_Ingreso> obtenerDetalleTiposIngresos (Context contexto)
    {

        String consulta;
        List<T_tipo_Ingreso.Tipo_Ingreso> mtiposingresos= new ArrayList<>();
        T_tipo_Ingreso.Tipo_Ingreso ingreso;


        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);


        consulta=" select * from tipoingreso ";

        Cursor c = db.rawQuery(consulta,null);

        c.moveToFirst();

        while (!c.isAfterLast())
        {
            //0 ID INTEGER PRIMARY KEY AUTOINCREMENT ,
            // 1 DESCRIPCION TEXT,
            // 2 ID_TIPO_INGRESO INTEGER

            ingreso = new T_tipo_Ingreso.Tipo_Ingreso();
            ingreso.idTipoIngreso=Integer.parseInt(c.getString(2));
            ingreso.descripcion=c.getString(2);

            mtiposingresos.add(ingreso); //add the item
            c.moveToNext();
        }


        return mtiposingresos;
    }


    public static class Tipo_Ingreso  extends SugarRecord {

        public Integer idTipoIngreso;
        public String descripcion;

        public Tipo_Ingreso() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Tipo_Ingreso(Integer idTipoIngreso, String descripcion) {
            this.idTipoIngreso = idTipoIngreso;
            this.descripcion = descripcion;
        }


        public Integer getidTipoIngreso() {
            return idTipoIngreso;
        }

        public void setidTipoIngreso(Integer idTipoIngreso) {
            this.idTipoIngreso = idTipoIngreso;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }


        @Override
        public String toString() {

            return "Tipo_Ingreso {" +
                    "idTipoIngreso='" + idTipoIngreso  +
                    ", descripcion=" + descripcion + '\'' +
                    '}';
        }
    }




}
