package edu.uoc.android.gfp.vistas.Deseo;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Deseo;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaDeseo extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtDescripcion, txtImporte, txtdFecha,txthFecha;;
    private Button btnModificar, btnEliminar;



    //Variables necesarias Deseo
    public Integer idDeseo;
    public String descripcion;
    public float importe;
    public String desdeFecha;
    public String hastaFecha;
    public String idUsuario;



    //Deseo que recuperamos de la BD
    public T_Deseo.Deseo mdeseo;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichapresupuesto);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idDeseo =getIntent().getExtras().getInt("arg_idDeseo");

            //Ojo para probar el formulario de modificación
            mdeseo= T_Deseo.leerDeseo(idDeseo,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Deseo");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del deseo
            txtDescripcion = (TextView) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mdeseo.getdescripcion());

            txtImporte = (TextView) findViewById(R.id.t_importe);
            txtImporte.setText(mdeseo.getimporte().toString());

            txtdFecha = (TextView) findViewById(R.id.t_dfecha);
            txtdFecha.setText(mdeseo.getdesdeFecha());

            txthFecha = (TextView) findViewById(R.id.t_hfecha);
            txthFecha.setText(mdeseo.gethastaFecha());

            btnEliminar = (Button) findViewById(R.id.b_eliminar);
            btnModificar = (Button) findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener((View.OnClickListener) this);
            btnModificar.setOnClickListener((View.OnClickListener) this);

        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaDeseo.class);
                intent.putExtra("idDeseo", idDeseo);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;

            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaDeseo.class);
                intent.putExtra("idDeseo", idDeseo);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}