package edu.uoc.android.gfp.vistas.Detalles;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Detalle;
import edu.uoc.android.gfp.utilidades.UtilidadesConstantes;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class DetalleCompleto extends AppCompatActivity {


    private SimpleItemRecyclerViewAdapter adapter;
    private RecyclerView recyclerView;

    //Parámetros de la actividad
    public String idUsuario;

    UtilidadesConstantes constantes = new UtilidadesConstantes();

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.detallecompleto);

        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario= getIntent().getExtras().getString("idUsuario");
        

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Mensual");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        recyclerView = findViewById(R.id.lista_detalle);
        RecyclerView.LayoutManager layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);

        setupRecyclerView(recyclerView);

        UtilidadesFecha utilFecha = new UtilidadesFecha();
        utilFecha.obtenerMesAnyoActual();

        List<T_Detalle.Detalle> DETALLES = new ArrayList<>();

        DETALLES=T_Detalle.obtenerDetallesMensual(getApplicationContext(),idUsuario,utilFecha.mesActualNumero,utilFecha.anyoActual);

        if (DETALLES.size()==0)
        {
            Toast.makeText(DetalleCompleto.this, "No existen registros para el mes en curso", Toast.LENGTH_SHORT).show();
        }
        else {
            adapter.setItems(DETALLES);
        }
    }



    private void setupRecyclerView(@NonNull RecyclerView recyclerView)
    {
            adapter = new SimpleItemRecyclerViewAdapter(new ArrayList<T_Detalle.Detalle>());
            recyclerView.setAdapter(adapter);
    }

    public class SimpleItemRecyclerViewAdapter extends RecyclerView.Adapter<SimpleItemRecyclerViewAdapter.ViewHolder>
    {

            private List<T_Detalle.Detalle> mValues;

            public SimpleItemRecyclerViewAdapter(ArrayList<T_Detalle.Detalle> items)
            {
                mValues = items;
            }



            public void setItems(List<T_Detalle.Detalle> items) {
                    mValues = items;
            }

            @Override
            public int getItemViewType(int position) {
                int type;

                if (position % 2 == 0) {
                    type = 0;
                } else {
                    type = 1;
                }
                return type;
            }

            @Override
            public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType)
            {
                View view = null;

                view = LayoutInflater.from(parent.getContext())
                            .inflate(R.layout.frag_listado_detalle_completo, parent, false);

                if (viewType==0)
                    view.setBackgroundColor(R.color.colorListadoPar);
                else
                    view.setBackgroundColor(R.color.colorListadoImpar);

                return new ViewHolder(view);
            }

            @Override
            public void onBindViewHolder(final ViewHolder holder, final int position)
            {

                holder.t_categoria.setText(mValues.get(position).categoria);
                // FALTA revisar para que cambie el icono holder.img_operacion.setImageResource(mValues.get(position).imagen);
                holder.img_operacion.setImageResource(R.drawable.monedas);
                holder.t_id_operacion.setText(String.valueOf(mValues.get(position).id_operacion));
                holder.t_importe.setText(String.valueOf(mValues.get(position).importe));
                holder.t_descripcion.setText(mValues.get(position).descripcion);

                holder.mView.setTag(mValues.get(position).tipo + "_" + String.valueOf(mValues.get(position).id_operacion));

                holder.mView.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {

                        String ident;
                        String categoria=null;
                        Integer cod=null;

                        ident = v.getTag().toString();

                        if (ident.indexOf(constantes.TIPO_GASTO) != -1)
                        {
                            categoria=constantes.TIPO_GASTO;
                            cod=Integer.valueOf(ident.replace(constantes.TIPO_GASTO + "_" ,""));
                        }

                        if (ident.indexOf(constantes.TIPO_INGRESO) != -1)
                        {
                            categoria=constantes.TIPO_INGRESO;
                            cod=Integer.valueOf(ident.replace(constantes.TIPO_INGRESO + "_" ,""));
                        }

                        Context context = v.getContext();

                        Intent intent;
                        intent = new Intent(context, DetalleOperacion.class);
                        //FALTA revisar el valor de los parámetros
                        intent.putExtra("arg_categoria", categoria);
                        intent.putExtra("arg_idOperacion", cod);
                        intent.putExtra("arg_idUsuario", idUsuario);
                        startActivity(intent);

                    }
                });
            }

            @Override
            public int getItemCount() {
                return mValues.size();
            }

            public class ViewHolder extends RecyclerView.ViewHolder
            {
                public final View mView;
                public TextView t_id_operacion=null;
                public TextView t_descripcion=null;
                public TextView t_categoria=null;
                public ImageView img_operacion=null;
                public TextView t_importe=null;
                public T_Detalle.Detalle mItem;

                public ViewHolder(View view) {
                    super(view);
                    mView = view;
                    t_id_operacion = view.findViewById(R.id.t_id_operacion);
                    t_descripcion = view.findViewById(R.id.t_descripcion);
                    t_categoria = view.findViewById(R.id.t_categoria);
                    img_operacion = view.findViewById(R.id.img_operacion);
                    t_importe = view.findViewById(R.id.t_importe);

                }

                @Override
                public String toString() {
                    return super.toString() + " '" + t_descripcion.getText() + "'";
                }
            }
        }
    }
