package edu.uoc.android.gfp.vistas.Gasto;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Gasto;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaGasto extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtDescripcion, txtImporte, txtFecha;
    private Button btnModificar, btnEliminar;
    private TextView despTipoGasto, despPeriodicidad;


    //Variables necesarias para registrar un Gasto
    public Integer idGasto=0;
    public String descripcion;
    public Integer idTipoGasto=-1;
    public float importe;
    public String fechaGasto;
    public Integer idPeriodicidad=-1;
    public Integer idNecesidad=1;
    public String idUsuario;

    public String tipoGasto="";
    public String periodicidad="";
    public String necesidad="";


    //Gasto que recuperamos de la BD
    public T_Gasto.Gasto mgasto;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichagasto);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idGasto =getIntent().getExtras().getInt("arg_idGasto");

            //Ojo para probar el formulario de modificación
            mgasto= T_Gasto.leerGasto(idGasto,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Gasto");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del gasto
            txtDescripcion = (TextView) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mgasto.getdescripcion());

            txtImporte = (TextView) findViewById(R.id.t_importe);
            txtImporte.setText(mgasto.getimporte().toString());

            txtFecha = (TextView) findViewById(R.id.t_fecha);
            txtFecha.setText(mgasto.getfechaGasto());

            btnEliminar = (Button) findViewById(R.id.b_eliminar);
            btnModificar = (Button) findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener((View.OnClickListener) this);
            btnModificar.setOnClickListener((View.OnClickListener) this);


            despTipoGasto = (TextView) findViewById(R.id.t_tipogasto);
            despTipoGasto.setText(mgasto.getTipoGasto());

            despPeriodicidad = (TextView) findViewById(R.id.t_periodicidad);
            despPeriodicidad.setText(mgasto.getPeriodicidad());


        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaGasto.class);
                intent.putExtra("idGasto", idGasto);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaGasto.class);
                intent.putExtra("idGasto", idGasto);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}