package edu.uoc.android.gfp.vistas.Ingreso;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Ingreso;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaIngreso extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtDescripcion, txtImporte, txtFecha;
    private Button btnModificar, btnEliminar;
    private TextView despTipoIngreso, despPeriodicidad;


    //Variables necesarias Ingreso
    public Integer idIngreso=0;
    public String descripcion;
    public Integer idTipoIngreso=-1;
    public float importe;
    public String fechaGasto;
    public Integer idPeriodicidad=-1;
    public String idUsuario;

    public String tipoIngreso="";
    public String periodicidad="";
    public String necesidad="";


    //Ingreso que recuperamos de la BD
    public T_Ingreso.Ingreso mingreso;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichaingreso);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idIngreso =getIntent().getExtras().getInt("arg_idIngreso");

            //Ojo para probar el formulario de modificación
            mingreso= T_Ingreso.leerIngreso(idIngreso,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Ingreso");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del ingreso
            txtDescripcion = (TextView) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mingreso.getdescripcion());

            txtImporte = (TextView) findViewById(R.id.t_importe);
            txtImporte.setText(mingreso.getimporte().toString());

            txtFecha = (TextView) findViewById(R.id.t_fecha);
            txtFecha.setText(mingreso.getFechaIngreso());

            btnEliminar = (Button) findViewById(R.id.b_eliminar);
            btnModificar = (Button) findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener((View.OnClickListener) this);
            btnModificar.setOnClickListener((View.OnClickListener) this);


            despTipoIngreso = (TextView) findViewById(R.id.t_tipoingreso);
            despTipoIngreso.setText(mingreso.getTipoIngreso());

            despPeriodicidad = (TextView) findViewById(R.id.t_periodicidad);
            despPeriodicidad.setText(mingreso.getPeriodicidad());


        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaIngreso.class);
                intent.putExtra("idIngreso", idIngreso);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaIngreso.class);
                intent.putExtra("idIngreso", idIngreso);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}