package edu.uoc.android.gfp.vistas.Presupuesto;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Presupuesto;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;


public class ModificaPresupuesto extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtImporte, txtdFecha, txthFecha;
    private Button btnCancelar, btnGuardar;


    //Variables necesarias Presupuesto
    public Integer idPresupuesto=0;
    public String descripcion;
    public float importe;
    public String desdeFecha;
    public String hastaFecha;
    public String idUsuario;


    //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
    public UtilidadesTeclado utilTecla;
    public UtilidadesFecha utilFecha;

    //Presupuesto que recuperamos de la BD
    public T_Presupuesto.Presupuesto mpresupuesto;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.modificadeseo);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("idUsuario");
            idPresupuesto =getIntent().getExtras().getInt("idPresupuesto");

            //Ojo para probar el formulario de modificación
            mpresupuesto= T_Presupuesto.leerPresupuesto(idPresupuesto,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Modifica Presupuesto");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del gasto
            txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mpresupuesto.getdescripcion());
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtImporte = (EditText) findViewById(R.id.t_importe);
            txtImporte.setText(mpresupuesto.getimporte().toString());
            txtImporte.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtdFecha = (EditText) findViewById(R.id.t_dfecha);
            txtdFecha.setText(mpresupuesto.getdesdeFecha());
            txtdFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        if (!txtdFecha.getText().toString().isEmpty())
                        {
                            if (!utilFecha.validarFecha(txtdFecha.getText().toString())) {
                                //La validación de la fecha no ha sido correcta
                                //mostramos mensaje
                                Toast.makeText(ModificaPresupuesto.this, "Formato de fecha incorrecto mm/dd/yyyy", Toast.LENGTH_SHORT).show();

                            }
                        }
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txthFecha = (EditText) findViewById(R.id.t_hfecha);
            txthFecha.setText(mpresupuesto.gethastaFecha());
            txthFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        if (!txthFecha.getText().toString().isEmpty())
                        {
                            if (!utilFecha.validarFecha(txthFecha.getText().toString())) {
                                //La validación de la fecha no ha sido correcta
                                //mostramos mensaje
                                Toast.makeText(ModificaPresupuesto.this, "Formato de fecha incorrecto mm/dd/yyyy", Toast.LENGTH_SHORT).show();

                            }
                        }
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);


        }


    }




    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

                //Se almacena en BD la info relativa al tipo de gasto
                //primero se debe validar si los campos están informados correctamente
                T_Presupuesto t_ultimoGasto= new T_Presupuesto();

                descripcion=txtDescripcion.getText().toString();
                //el valor ya está asignado idTipoGasto
                importe= Float.parseFloat(txtImporte.getText().toString());
                desdeFecha=txtdFecha.getText().toString();
                hastaFecha=txthFecha.getText().toString();

                //el valor ya está asignado idPeriodicidad
                //el valor ya está asignado idNecesidad;
                //el valor ya está asignado idUsuario;

                if (idPresupuesto.toString().isEmpty())
                    continua=false;

                if (descripcion.toString().isEmpty())
                    continua=false;

                if (txtImporte.getText().toString().isEmpty())
                    continua=false;

                if (txtdFecha.getText().toString().isEmpty())
                    continua=false;

                if (txthFecha.getText().toString().isEmpty())
                    continua=false;


                if (continua==true)
                {
                    myApplication.modificaPresupuesto (idPresupuesto,descripcion,importe,desdeFecha,hastaFecha,idUsuario);

                    desdeFecha=utilFecha.formatearFecha(txtdFecha.getText().toString());
                    hastaFecha=utilFecha.formatearFecha(txthFecha.getText().toString());


                    //Envio de nuevo a la ficha del deseo
                    Intent intent_mg = new Intent(getApplicationContext(), FichaPresupuesto.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    intent_mg.putExtra("arg_idPresupuesto", idPresupuesto);
                    startActivity(intent_mg);

                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Envio de nuevo a la ficha del presupuesto
                Intent intent_mg = new Intent(getApplicationContext(), FichaPresupuesto.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                intent_mg.putExtra("arg_idPresupuesto", idPresupuesto);
                startActivity(intent_mg);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}