package edu.uoc.android.gfp.vistas.Situacion;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Situacion;
import edu.uoc.android.gfp.modeloDatos.T_tipo_Gasto;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;

public class FichaSituacion extends AppCompatActivity
{
    public String idUsuario;

    // Variables de los elementos de la pantalla
    private EditText txtDescripcion,txtRelacionGastoIngreso ;
    private Button btnEliminar, btnModificar;

    public String descripcion;
    public String relacion;
    public Integer idSituacion;

    public T_Situacion.Situacion msituacion;

    public MyApplication myApplication;

    @Override
    protected void onCreate (Bundle savedInstanceState)
    {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.registrosituacion);


        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("arg_idUsuario");
        idSituacion = getIntent().getExtras().getInt("arg_idSituacion");

        myApplication = (MyApplication) getApplicationContext();

        msituacion= T_Situacion.leerSituacion(idSituacion,idUsuario);

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Registro Situación");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
        final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


        //Inicialización de todos los elementos de la pantalla

        txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
        txtDescripcion.setText(msituacion.getdescripcion());

        txtRelacionGastoIngreso = (EditText) findViewById(R.id.t_relacion);
        txtRelacionGastoIngreso.setText(msituacion.getrelacionGastoIngreso());

        btnEliminar = (Button) findViewById(R.id.b_eliminar);
        btnModificar = (Button) findViewById(R.id.b_modificar);

        // Metodos Listener
        btnEliminar.setOnClickListener((View.OnClickListener) this);
        btnModificar.setOnClickListener((View.OnClickListener) this);

    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        switch (v.getId()) {
            case R.id.b_modificar:

                    Intent intent_ms = new Intent(getApplicationContext(), ModificaSituacion.class);
                    intent_ms.putExtra("arg_idUsuario", idUsuario);
                    intent_ms.putExtra("arg_idSituacion", idSituacion);
                    startActivity(intent_ms);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {

    }
}