package edu.uoc.android.gfp.vistas.Situacion;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;
import edu.uoc.android.gfp.vistas.TipoGasto.DetalleTipoGasto;

public class RegistroSituacion extends AppCompatActivity
{
    public String idUsuario;

    // Variables de los elementos de la pantalla
    private EditText txtDescripcion,txtRelacionGastoIngreso ;
    private Button btnCancelar, btnGuardar;

    public String descripcion;
    public String relacion;
    public Integer idSituacion;

    public MyApplication myApplication;

    @Override
    protected void onCreate (Bundle savedInstanceState)
    {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.registrosituacion);


        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("idUsuario");
        myApplication = (MyApplication) getApplicationContext();

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Registro Situación");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
        final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


        //Inicialización de todos los elementos de la pantalla

        txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
        txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        txtRelacionGastoIngreso = (EditText) findViewById(R.id.t_relacion);
        txtRelacionGastoIngreso.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        btnCancelar = (Button) findViewById(R.id.b_cancelar);
        btnGuardar = (Button) findViewById(R.id.b_guardar);

        // Metodos Listener
        btnCancelar.setOnClickListener((View.OnClickListener) this);
        btnGuardar.setOnClickListener((View.OnClickListener) this);

    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        switch (v.getId()) {
            case R.id.b_guardar:

                if (txtDescripcion.toString().isEmpty())
                    continua=false;

                if (txtRelacionGastoIngreso.toString().isEmpty())
                    continua=false;



                if (continua==true)
                {


                    descripcion=txtDescripcion.getText().toString();
                    relacion=txtRelacionGastoIngreso.getText().toString();

                    idSituacion=myApplication.altaSituacion(descripcion,relacion,idUsuario);

                    //Una vez se ha registadrado el gasto se redirige a la ficha del gasto
                    Intent intent_mg = new Intent(getApplicationContext(), FichaSituacion.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    intent_mg.putExtra("arg_idSituacion", idSituacion);
                    startActivity(intent_mg);


                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:
                //Se cancela el formulario se resetea.

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {

    }
}