package edu.uoc.android.gfp.vistas.TipoIngreso;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_tipo_Ingreso;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class ModificaTipoIngreso extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion;
    private Button btnCancelar, btnGuardar;


    //Variables necesarias para modificar un ingreso
    public Integer idTipoIngreso=0;
    public String descripcion;


    public String idUsuario;

    //Tipo Ingreso que recuperamos de la BD
    public T_tipo_Ingreso.Tipo_Ingreso mtipoingreso;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.modificatipoingreso);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idTipoIngreso =getIntent().getExtras().getInt("arg_idTipoIngreso");

            //Ojo para probar el formulario de modificación
            mtipoingreso= T_tipo_Ingreso.leerTipoIngreso(idTipoIngreso);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Modifica Tipo Gasto");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del deseo
            txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mtipoingreso.getdescripcion());
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);




    }




    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

                //Se almacena en BD la info relativa al tipo de gasto
                //primero se debe validar si los campos están informados correctamente

                if (txtDescripcion.getText().toString().isEmpty())
                    continua=false;



                if (continua==true)
                {
                    myApplication.modificaTipoIngreso (idTipoIngreso,descripcion);
                    //Envio de nuevo a la ficha del gasto
                    Intent intent_mg = new Intent(getApplicationContext(), DetalleTipoIngreso.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    startActivity(intent_mg);

                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), DetalleTipoIngreso.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_mg);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}