package edu.uoc.android.gfp.vistas.usuario;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;
import edu.uoc.android.gfp.vistas.Login;

public class BajaUsuario extends AppCompatActivity {

    public String idUsuario;
    public Integer codUsuario;
    public MyApplication myApplication;


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.bajausuario);

        myApplication = (MyApplication) getApplicationContext();

        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("idUsuario");
        codUsuario = getIntent().getExtras().getInt("codUsuario");

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Eliminar Usuario");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        AlertDialog.Builder confirmacionBorrado = new AlertDialog.Builder(this);

        confirmacionBorrado.setTitle("Eliminar Definitivamente Usuario");

        confirmacionBorrado.setMessage("¿Está seguro que desea eliminar el Usuario?");

        confirmacionBorrado.setCancelable(false);

        confirmacionBorrado.setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                borrarUsuario();
            }
        });

        confirmacionBorrado.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                cancelar();
            }
        });

        confirmacionBorrado.show();

    }


    private void borrarUsuario()
    {

        myApplication.bajaUsuario(codUsuario);

        //Enviamos a la pantalla de Bienvenida , posible mejora a la pantalla anterior a la eliminación
        Intent intent = new Intent(this, Login.class);
        startActivity(intent);
    }

    private void cancelar()
    {
        //en el caso que el usuario no confirme la eliminación enviamos a la ficha del gasto, posible
        //mejora ir a la pantalla anterior a la eliminación
        Intent intent = new Intent(this, FichaUsuario.class);
        intent.putExtra("arg_codUsuario", codUsuario);
        intent.putExtra("arg_idUsuario", idUsuario);
        startActivity(intent);
    }

}