package edu.uoc.android.gfp.vistas.usuario;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.Login;


public class RegistroUsuario extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtNombreCompleto,txtIdUsuario,txtPassword,txtEmail;
    private Spinner despAlimentacion;
    private CheckBox checkNotificarEmail;

    private Button btnCancelar, btnGuardar;



    //Variables necesarias para registrar un Ingreso
    public String nombreCompleto;
    public Integer codUsuario=-1;
    public String idUsuario;
    public String password;
    public String email;
    public String notificarEmail;
    public Integer idAlimentacion;
    public String alimentacion;


    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.registrousuario);


            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);

            //Inicialización de todos los elementos de la pantalla

            txtNombreCompleto = (EditText) findViewById(R.id.t_nombre_completo);
            txtNombreCompleto.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtIdUsuario = (EditText) findViewById(R.id.t_idusuario);
            txtIdUsuario.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtPassword = (EditText) findViewById(R.id.t_password);
            txtPassword.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtEmail = (EditText) findViewById(R.id.t_email);
            txtEmail.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            checkNotificarEmail=(CheckBox) findViewById(R.id.c_notificar_email);

            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);


            despAlimentacion = (Spinner) findViewById(R.id.desp_alimentacion);

            myApplication = (MyApplication) getApplicationContext();


            // Carga desplegable de tipo Gasto
            despAlimentacion.setAdapter((ArrayAdapter<String>) myApplication.cargaAlimentacion());

            despAlimentacion.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

                @Override
                public void onItemSelected(AdapterView<?> arg0, View arg1,
                                           int pos, long id) {

                    String descripcion = arg0.getItemAtPosition(pos)
                            .toString();

                    if (descripcion.equals(getResources().getString(R.string.ini_spinner))) {
                        //No se entiende seleccionado ningún valor
                        alimentacion="";
                        idAlimentacion = -1;
                    } else {
                        alimentacion=descripcion;
                        idAlimentacion = pos;
                     }

                }

                @Override
                public void onNothingSelected(AdapterView<?> arg0) {
                    // TODO Auto-generated method stub

                }
            });


        }


    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;


        switch (v.getId()) {
            case R.id.b_guardar:

             if (txtNombreCompleto.toString().isEmpty())
                    continua=false;

                if (txtIdUsuario.getText().toString().isEmpty())
                    continua=false;

                if (txtPassword.getText().toString().isEmpty())
                    continua=false;

                if (txtPassword.getText().toString().isEmpty())
                    continua=false;

                if (idAlimentacion==-1)
                    continua=false;

                if (continua==true)
                {


                    nombreCompleto=txtNombreCompleto.getText().toString();
                    idUsuario=txtIdUsuario.getText().toString();
                    password=txtPassword.getText().toString();
                    email=txtEmail.getText().toString();

                    if (checkNotificarEmail.isChecked())
                        notificarEmail="S";
                    else
                        notificarEmail="N";

                    codUsuario=myApplication.altaUsuario(idUsuario,password,nombreCompleto,email,idAlimentacion,alimentacion,notificarEmail);

                    Intent intent_mg = new Intent(getApplicationContext(), Login.class);
                    startActivity(intent_mg);


                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:
                //Se cancela el formulario se resetea.

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {

    }
}