package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.support.annotation.RequiresApi;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.gfp.utilidades.UtilidadesFecha;

public class T_Cuenta_Bancaria {

    public static final List<Cuenta_Bancaria> CUENTAS_BANCARIAS = new ArrayList<>();

    //Procedimiento para obtener el total de Cuentas Bancarias en la BD local
    public static List<Cuenta_Bancaria> obtenerTodosCuentasBancarias() {

        return  Cuenta_Bancaria.listAll(Cuenta_Bancaria.class);

    }

    //Procedimiento para obtener el total de Deseos en la BD local asociados al usuario
    //que ha hecho Login
    public static List<Cuenta_Bancaria> obtenerTodasCuentasBancarias(String idUsuario) {

        List<Cuenta_Bancaria> Deseos = Cuenta_Bancaria.find(Cuenta_Bancaria.class, "id_Usuario = ?", idUsuario);
        return Deseos;

    }

    //Procedimiento para comprobar si Deseo ya existe en la BD local
    public static boolean existe(Cuenta_Bancaria tCuenta_Bancaria) {

        List<Cuenta_Bancaria> mcuentaBancaria = Cuenta_Bancaria.find(Cuenta_Bancaria.class, "id_Cuenta = ?", tCuenta_Bancaria.getIdCuenta().toString());

        if (mcuentaBancaria == null || mcuentaBancaria.size() == 0) {
            return false;
        } else {
            return true;
        }

    }


    public static Cuenta_Bancaria leerCuentaBancaria(Integer idCuenta,String idUsuario){

        List<Cuenta_Bancaria> mDeseos = Select.from(Cuenta_Bancaria.class)
                .where(Condition.prop("id_Usuario").eq(idUsuario),
                        Condition.prop("id_cuenta").eq(idCuenta))
                .list();
        return mDeseos.get(0);

    }


    public static void eliminaCuentaBancaria(Context contexto, Integer idCuenta){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        SQLiteStatement query = db.compileStatement("delete from cuentabancaria where id_cuenta=" + idCuenta);
        query.execute();
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    public static Integer altaCuentaBancaria(Context contexto, String descripcion,String numeroCuenta,String idUsuario){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long idCuenta;


        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);
        contentValues.put("numero_cuenta", numeroCuenta);
        contentValues.put("id_usuario", idUsuario);

        idCuenta=db.insert("cuentabancaria","descripcion,numero_cuenta,id_usuario",contentValues);

        SQLiteStatement query = db.compileStatement("update cuentabancaria set id_cuenta=" + idCuenta + " where id=" + idCuenta);
        query.execute();

        return Math.toIntExact(idCuenta);

    }

    public static void modificaCuentaBancaria (Context contexto,Integer idCuenta,String descripcion,String numeroCuenta,String idUsuario ){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);
        contentValues.put("numero_cuenta", numeroCuenta);
        contentValues.put("id_usuario", idUsuario);

        db.update("cuentabancaria",contentValues,"id_cuenta = ? ", new String[]{idCuenta.toString()});

    }

    public static List<T_Cuenta_Bancaria.Cuenta_Bancaria> obtenerDetalleCuentasBancarias (Context contexto, String descripcion, String numeroCuenta,String idUsuario)
    {

        List<T_Cuenta_Bancaria.Cuenta_Bancaria> mcuentas= new ArrayList<>();
        T_Cuenta_Bancaria.Cuenta_Bancaria cuenta;

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        String consulta;
        String condicion="";
        String separador;


        separador="";

        if (!descripcion.isEmpty())
        {
            condicion= " descipcion ='" + descripcion + "' ";
            separador=" and ";
        }


        if (!numeroCuenta.isEmpty())
        {
            condicion= condicion + separador + " numero_cuenta='" + numeroCuenta + "'";
            separador=" and ";
        }

        consulta=" select * from cuentabancaria ";

        if (!condicion.isEmpty())
            consulta = consulta + " where "  + condicion;

        Cursor c = db.rawQuery(consulta,null);

        c.moveToFirst();

        while (!c.isAfterLast())
        {

            // 0 ID INTEGER PRIMARY KEY AUTOINCREMENT ,
            // 1 DESCRIPCION TEXT,
            // 2 ID_CUENTA INTEGER,
            // 3 ID_USUARIO TEXT,
            // 4 NUMERO_CUENTA TEXT

            cuenta = new T_Cuenta_Bancaria.Cuenta_Bancaria();
            cuenta.idCuenta=Integer.parseInt(c.getString(2));
            cuenta.descripcion=c.getString(1);
            cuenta.numeroCuenta=c.getString(4);
            cuenta.idUsuario=c.getString(3);

            mcuentas.add(cuenta); //add the item
            c.moveToNext();
        }


        return mcuentas;
    }



    public static class Cuenta_Bancaria extends  SugarRecord {

        public Integer idCuenta;
        public String descripcion;
        public String numeroCuenta;
        public String idUsuario;

        public Cuenta_Bancaria() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Cuenta_Bancaria(Integer idCuenta, String descripcion,String numeroCuenta,String idUsuario) {
            this.idCuenta = idCuenta;
            this.descripcion = descripcion;
            this.numeroCuenta=numeroCuenta;
            this.idUsuario=idUsuario;
        }


        public Integer getIdCuenta() {
            return idCuenta;
        }

        public void setIdCuenta(Integer idCuenta) {
            this.idCuenta = idCuenta;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public String getnumeroCuenta() {
            return numeroCuenta;
        }

        public void setnumeroCuenta(String numeroCuenta) {
            this.numeroCuenta = numeroCuenta;
        }

        public String getidUsuario() {
            return idUsuario;
        }

        public void setidUsuario(String idUsuario) {
            this.idUsuario = idUsuario;
        }

        @Override
        public String toString() {

            return "Cuenta_Bancaria {" +
                    "idCuenta=" + idCuenta +
                    "descripcion='" + descripcion + '\'' +
                    "numeroCuenta=" + numeroCuenta +
                    "idUsuario='" + idUsuario + '\'' +
                    '}';
        }



    }







}