package edu.uoc.android.gfp.modeloDatos;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import com.orm.SugarRecord;
import com.orm.query.Condition;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.gfp.utilidades.UtilidadesConstantes;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;

public class T_Detalle {


    public static  List<Detalle>  obtenerDetallesMensual (Context contexto, String idUsuario, Integer mes, Integer anyo)
    {

       Detalle operacion = null;
       List<Detalle> detalleMensual= new ArrayList<>();
       String mesCadena,anyoCadena;

       String[] COLUMNAS_GASTO = {"id_Gasto","descripcion","importe","fecha_Gasto"};
       String[] COLUMNAS_INGRESO = {"id_Ingreso","descripcion","importe","fecha_Ingreso"};


       mesCadena=mes.toString();
       anyoCadena=anyo.toString();

       if (mesCadena.length()==1)
           mesCadena='0' + mesCadena;


        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);



        // SE Insertan los gastos
        Cursor  cursor = db.query("Gasto",COLUMNAS_GASTO,"strftime('%m/%Y', fecha_Gasto)=? ", new String[]{mesCadena + "/" + anyo}, null, null, null);

        if (cursor.moveToFirst()) {
            do {


                // Añadimos a la lista que devolveremos como salida
                // del método el nombre de la ciudad en la posición actual
                operacion = new Detalle();
                operacion.id_operacion=Integer.parseInt(cursor.getString(0));
                operacion.categoria=cursor.getString(3) + " Gasto"; // Para facilitar formato pantalla
                operacion.imagen="@drawable/ticket";
                operacion.descripcion=cursor.getString(1);
                operacion.importe=Float.parseFloat(cursor.getString(2));
                operacion.fecha=cursor.getString(3);
                operacion.tipo=UtilidadesConstantes.TIPO_GASTO;
                detalleMensual.add(operacion);

                // El método moveToNext devolverá false en el caso de que se
                // haya llegado al final

            } while (cursor.moveToNext());
        }
        if (cursor != null && !cursor.isClosed()) {
            cursor.close();
        }


        // SE Insertan los ingresos
        cursor = db.query("Ingreso",COLUMNAS_INGRESO,"strftime('%m/%Y', fecha_Ingreso)=? ", new String[]{mesCadena + "/" + anyo}, null, null, null);

        if (cursor.moveToFirst()) {
            do {


                // Añadimos a la lista que devolveremos como salida
                // del método el nombre de la ciudad en la posición actual
                operacion = new Detalle();
                operacion.id_operacion=Integer.parseInt(cursor.getString(0));
                operacion.categoria=cursor.getString(3) + " Ingreso";  // Para facilitar formato pantalla
                operacion.imagen="@drawable/recibirefectivo";
                operacion.descripcion=cursor.getString(1);
                operacion.importe=Float.parseFloat(cursor.getString(2));
                operacion.fecha=cursor.getString(3);
                operacion.tipo=UtilidadesConstantes.TIPO_INGRESO;
                detalleMensual.add(operacion);

                // El método moveToNext devolverá false en el caso de que se
                // haya llegado al final

            } while (cursor.moveToNext());
        }
        if (cursor != null && !cursor.isClosed()) {
            cursor.close();
        }


        return detalleMensual;
    }



    public static class Detalle {

        public Integer id_operacion;
        public String imagen;
        public String descripcion;
        public float importe;
        public String categoria;
        public String fecha;
        public String tipo;


    }

}