package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import com.orm.SugarRecord;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_tipo_Necesidad {

         public static final List<Tipo_Necesidad> TIPOS_NECESIDAD = new ArrayList<>();


        //Procedimiento para obtener el total de tipos de gastos en la BD local
        public static Integer obtenerRecuentoTiposNecesidad(){

            return Tipo_Necesidad.listAll(Tipo_Necesidad.class).size();
        }

         //Procedimiento para obtener el total de tipos de NECESIDAD en la BD local
        public static List<Tipo_Necesidad> obtenerTodosTiposNecesidad(){

            return Tipo_Necesidad.listAll(Tipo_Necesidad.class);

        }

        //Procedimiento para comprobar si un Tipo de Necesidad ya existe en la BD local
        public static boolean existe(Tipo_Necesidad tNecesidad) {

            List<Tipo_Necesidad> mNecesidad = Tipo_Necesidad.find(Tipo_Necesidad.class, "id_Necesidad = ?", tNecesidad.getidNecesidad().toString());

            if (mNecesidad == null || mNecesidad.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idTipoNecesidad
    public static Integer ultimoIdNecesidad ()
    {

        List<Tipo_Necesidad> ultimoNecesidad = Select.from(Tipo_Necesidad.class)
                .orderBy("id_Necesidad")
                .list();

        if (ultimoNecesidad.size()>0)
            return ultimoNecesidad.get(0).getidNecesidad();
        else
            return 0;

    }


    public static Integer altaTipoNecesidad(Context contexto, String descripcion){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long idNecesidad;


        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);


        idNecesidad=db.insert("tiponecesidad","descripcion",contentValues);

        SQLiteStatement query = db.compileStatement("update tiponecesidad set id_necesidad=" + idNecesidad + " where id=" + idNecesidad);
        query.execute();

        return Math.toIntExact(idNecesidad);

    }

    public static class Tipo_Necesidad  extends SugarRecord {

        public Integer idNecesidad;
        public String descripcion;

        public Tipo_Necesidad() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Tipo_Necesidad(Integer idTipoIngreso, String descripcion) {
            this.idNecesidad = idTipoIngreso;
            this.descripcion = descripcion;
        }


        public Integer getidNecesidad() {
            return idNecesidad;
        }

        public void setidNecesidad(Integer idNecesidad) {
            this.idNecesidad = idNecesidad;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }


        @Override
        public String toString() {

            return "Tipo_Necesidad{" +
                    "idNecesidad='" + idNecesidad  +
                    ", descripcion=" + descripcion + '\'' +
                    '}';
        }
    }


}
