package edu.uoc.android.gfp.modeloDatos;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import com.orm.SugarRecord;
import com.orm.query.Select;

import java.util.ArrayList;
import java.util.List;

public class T_tipo_Periodicidad {

         public static final List<Tipo_Periodicidad> TIPOS_PERIODICIDAD = new ArrayList<>();

     //Procedimiento para obtener el total de tipos de gastos en la BD local
     public static Integer obtenerRecuentoTiposPeriodicidad(){

        return Tipo_Periodicidad.listAll(Tipo_Periodicidad.class).size();
        }


    //Procedimiento para obtener el total de tipos de PERIODICIDAD en la BD local
        public static List<Tipo_Periodicidad> obtenerTodosTiposPeriodicidad(){

            return Tipo_Periodicidad.listAll(Tipo_Periodicidad.class);

        }

        //Procedimiento para comprobar si un Tipo de PERIODICIDAD ya existe en la BD local
        public static boolean existe(Tipo_Periodicidad tPeriodicidad) {

            List<Tipo_Periodicidad> mPeriodicidad = Tipo_Periodicidad.find(Tipo_Periodicidad.class, "descripcion = ?", tPeriodicidad.descripcion);

            if (mPeriodicidad == null || mPeriodicidad.size() == 0) {
                return false;
            } else {
                return true;
            }

        }

        //Procedimiento para obtener el último idPeriodicidad
    public static Integer ultimoIdPeriodicidad ()
    {

        List<Tipo_Periodicidad> ultimoPeriodicidad = Select.from(Tipo_Periodicidad.class)
                .orderBy("id_Periodicidad")
                .list();

        if (ultimoPeriodicidad.size()>0)
            return ultimoPeriodicidad.get(0).getIdPeriodicidad();
        else
            return 0;

    }

    public static Integer altaTipoPeriodicidad(Context contexto, String descripcion){

        SQLiteDatabase db = contexto.openOrCreateDatabase("BDTFM", contexto.MODE_PRIVATE, null);

        long idPeriodicidad;


        ContentValues contentValues = new ContentValues();
        contentValues.put("descripcion", descripcion);


        idPeriodicidad=db.insert("tipoperiodicidad","descripcion",contentValues);

        SQLiteStatement query = db.compileStatement("update tipoperiodicidad set id_periodicidad=" + idPeriodicidad + " where id=" + idPeriodicidad);
        query.execute();

        return Math.toIntExact(idPeriodicidad);

    }


    public static class Tipo_Periodicidad  extends SugarRecord {

        public Integer idPeriodicidad;
        public String descripcion;

        public Tipo_Periodicidad() {
            // Default constructor required for calls to DataSnapshot.getValue(User.class)
        }

        public Tipo_Periodicidad(Integer idPeriodicidad, String descripcion) {
            this.idPeriodicidad = idPeriodicidad;
            this.descripcion = descripcion;
        }


        public Integer getIdPeriodicidad() {
            return idPeriodicidad;
        }

        public void setIdPeriodicidad(Integer idPeriodicidad) {
            this.idPeriodicidad = idPeriodicidad;
        }

        public String getdescripcion() {
            return descripcion;
        }

        public void setdescripcion(String descripcion) {
            this.descripcion = descripcion;
        }




        @Override
        public String toString() {

            return "Tipo_Periodicidad {" +
                    "idPeriodicidad='" + idPeriodicidad  +
                    ", descripcion=" + descripcion + '\'' +
                    '}';
        }
    }


}
