package edu.uoc.android.gfp.vistas;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;

import edu.uoc.android.gfp.R;

public class CierreSesion extends AppCompatActivity {


    public String idUsuario;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.cerrarsesion);


        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario= getIntent().getExtras().getString("idUsuario");

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Cierre de Sesión");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        AlertDialog.Builder confirmacionCerrar = new AlertDialog.Builder(this);

        confirmacionCerrar.setTitle("Desea Cerrar Gestión Finanzas Personales");

        confirmacionCerrar.setMessage("¿Está seguro que desea eliminar el Usuario?");

        confirmacionCerrar.setCancelable(false);

        confirmacionCerrar.setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                cerrar();
            }
        });

        confirmacionCerrar.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                cancelar();
            }
        });

        confirmacionCerrar.show();



    }


    private void cancelar()
    {
        //en el caso que el usuario no confirme la eliminación enviamos a la ficha del gasto, posible
        //mejora ir a la pantalla anterior a la eliminación
        Intent intent = new Intent(this, Bienvenida.class);
        intent.putExtra("idUsuario", idUsuario);
        finish();
        startActivity(intent);
    }

    @RequiresApi(api = Build.VERSION_CODES.JELLY_BEAN)
    private void cerrar()
    {
        finishAffinity();

    }




}
