package edu.uoc.android.gfp.vistas.Contribucion;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.Bienvenida;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;

public class BusquedaContribucion extends AppCompatActivity implements View.OnClickListener {

    public String idUsuario;

    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtdImporte, txthImporte,txtdFecha,txthFecha;
    private Button btnCancelar, btnBuscar;
    private Spinner despDeseo;

    public MyApplication myApplication;


    //Variables necesarias para la búsdueda
    public String descripcion;
    public Integer idDeseo=-1;
    public String dimporte,himporte;
    public String dfechaContribucion,hfechaContribucion;

    public String deseo="";





    @Override
    protected void onCreate (Bundle savedInstanceState)
    {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.busquedacontribucion);


        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("idUsuario");

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Buscar Contribuciones");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }



        myApplication = (MyApplication) getApplicationContext();

        //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
        final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


        txtDescripcion = findViewById(R.id.t_descripcion);
        txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });


        txtdImporte = findViewById(R.id.t_dimporte);
        txtdImporte.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        txthImporte = findViewById(R.id.t_himporte);
        txthImporte.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        txtdFecha = findViewById(R.id.t_dfecha);
        txtdFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        txthFecha = findViewById(R.id.t_hfecha);
        txthFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });

        btnCancelar = findViewById(R.id.b_cancelar);
        btnBuscar = findViewById(R.id.b_buscar);

        // Metodos Listener
        btnCancelar.setOnClickListener(this);
        btnBuscar.setOnClickListener(this);


        despDeseo = findViewById(R.id.t_deseo);



        // Carga desplegable de tipo Gasto
        despDeseo.setAdapter(myApplication.cargaDeseo(idUsuario));

        despDeseo.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

            @Override
            public void onItemSelected(AdapterView<?> arg0, View arg1,
                                       int pos, long id) {

                String descripcion = arg0.getItemAtPosition(pos)
                        .toString();

                if (descripcion.equals(getResources().getString(R.string.ini_spinner))) {
                    //No se entiende seleccionado ningún valor
                    idDeseo = -1;
                    deseo="";
                } else {

                    idDeseo = pos;
                    deseo=descripcion;
                }

            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
                // TODO Auto-generated method stub

            }
        });


    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_buscar:


                descripcion=txtDescripcion.getText().toString();
                dimporte=txtdImporte.getText().toString();
                himporte=txthImporte.getText().toString();
                dfechaContribucion=txtdFecha.getText().toString();
                hfechaContribucion=txthFecha.getText().toString();

                //Pasamos como argumentos todos los parámetros a la siguiente actividad
                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), DetalleContribuciones.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                intent_mg.putExtra("arg_descripcion", descripcion);
                intent_mg.putExtra("arg_dimporte",  dimporte);
                intent_mg.putExtra("arg_himporte", himporte);
                intent_mg.putExtra("arg_dfechaContribucion", dfechaContribucion);
                intent_mg.putExtra("arg_hfechaContribucion", hfechaContribucion);
                intent_mg.putExtra("arg_deseo", deseo);

                startActivity(intent_mg);




                break;
            case R.id.b_cancelar:

                Intent intent = new Intent(this, Bienvenida.class);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

}