package edu.uoc.android.gfp.vistas.Contribucion;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Contribucion;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaContribucion extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtDescripcion, txtImporte, txtFecha;
    private Button btnModificar, btnEliminar;
    private TextView despDeseo;


    //Variables necesarias Contribucion
    public Integer idContribucion=0;
    public String descripcion;
    public Integer idDeseo=-1;
    public float importe;
    public String fecha;
    public String idUsuario;

    public String deseo="";


    //Contribucion que recuperamos de la BD
    public T_Contribucion.Contribucion mcontribucion;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichacontribucion);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idContribucion =getIntent().getExtras().getInt("arg_idContribucion");

            //Ojo para probar el formulario de modificación
            mcontribucion= T_Contribucion.leerContribucion(idContribucion,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Contribución");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del ingreso
            txtDescripcion = findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mcontribucion.getdescripcion());

            txtImporte = findViewById(R.id.t_importe);
            txtImporte.setText(mcontribucion.getimporte().toString());

            txtFecha = findViewById(R.id.t_fecha);
            txtFecha.setText(mcontribucion.getFecha());

            btnEliminar = findViewById(R.id.b_eliminar);
            btnModificar = findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener(this);
            btnModificar.setOnClickListener(this);


            despDeseo = findViewById(R.id.t_deseo);
            despDeseo.setText(mcontribucion.getDeseo());


        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaContribucion.class);
                intent.putExtra("idContribucion", idContribucion);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaContribucion.class);
                intent.putExtra("idContribucion", idContribucion);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}