package edu.uoc.android.gfp.vistas.Contribucion;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Contribucion;
import edu.uoc.android.gfp.utilidades.UtilidadesDesplegable;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class ModificaContribucion extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtImporte, txtFecha;
    private Button btnCancelar, btnGuardar;
    private Spinner despDeseo;


    //Variables necesarias para modificar contribucion
    public Integer idContribucion=0;
    public String descripcion;
    public Integer idDeseo=-1;
    public float importe;
    public String fechaContribucion;
    public String idUsuario;
    public String deseo="";


    //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
    public UtilidadesTeclado utilTecla;
    public UtilidadesFecha utilFecha;

    //Ingreso que recuperamos de la BD
    public T_Contribucion.Contribucion mcontribucion;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.modificacontribucion);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("idUsuario");
            idContribucion =getIntent().getExtras().getInt("idContribucion");

            //Ojo para probar el formulario de modificación
            mcontribucion= T_Contribucion.leerContribucion(idContribucion,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Modifica Contribucion");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            utilTecla = new UtilidadesTeclado(this);
            utilFecha = new UtilidadesFecha();


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del deseo
            txtDescripcion = findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mcontribucion.getdescripcion());
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtImporte = findViewById(R.id.t_importe);
            txtImporte.setText(mcontribucion.getimporte().toString());
            txtImporte.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtFecha = findViewById(R.id.t_fecha);
            txtFecha.setText(utilFecha.formatearFechaInversa(mcontribucion.getFecha()));
            txtFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        if (!txtFecha.getText().toString().isEmpty())
                        {
                            if (!UtilidadesFecha.validarFecha(txtFecha.getText().toString())) {
                                //La validación de la fecha no ha sido correcta
                                //mostramos mensaje
                                Toast.makeText(ModificaContribucion.this, "Formato de fecha incorrecto mm/dd/yyyy", Toast.LENGTH_SHORT).show();

                            }
                        }
                    }
                }
            });

            btnCancelar = findViewById(R.id.b_cancelar);
            btnGuardar = findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener(this);
            btnGuardar.setOnClickListener(this);


            despDeseo = findViewById(R.id.t_deseo);



            // Carga desplegable de deseos
            despDeseo.setAdapter(myApplication.cargaDeseo(idUsuario));

            Integer indice = UtilidadesDesplegable.getIndex(despDeseo,mcontribucion.getDeseo());

            despDeseo.setSelection(indice);


            despDeseo.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

                @Override
                public void onItemSelected(AdapterView<?> arg0, View arg1,
                                           int pos, long id) {

                    String descripcion = arg0.getItemAtPosition(pos)
                            .toString();

                    if (descripcion.equals(getResources().getString(R.string.ini_spinner))) {
                        //No se entiende seleccionado ningún valor
                        idDeseo = -1;
                        deseo="";
                    } else {

                        idDeseo = pos;
                        deseo=descripcion;


                    }

                }

                @Override
                public void onNothingSelected(AdapterView<?> arg0) {
                    // TODO Auto-generated method stub

                }
            });


        }


    }




    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:


                descripcion=txtDescripcion.getText().toString();

                importe= Float.parseFloat(txtImporte.getText().toString());
                fechaContribucion= UtilidadesFecha.formatearFecha(txtFecha.getText().toString());

                if (idContribucion.toString().isEmpty())
                    continua=false;

                if (descripcion.isEmpty())
                    continua=false;

                if (txtImporte.getText().toString().isEmpty())
                    continua=false;

                if (txtFecha.getText().toString().isEmpty())
                    continua=false;

                if (idDeseo==-1)
                    continua=false;


                if (continua==true)
                {
                    fechaContribucion=utilFecha.formatearFecha(txtFecha.getText().toString());

                    myApplication.modificaContribucion (idContribucion,descripcion,idDeseo,importe,fechaContribucion,idUsuario,deseo);

                    Intent intent_mg = new Intent(getApplicationContext(), FichaContribucion.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    intent_mg.putExtra("arg_idContribucion", idContribucion);
                    startActivity(intent_mg);

                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), FichaContribucion.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                intent_mg.putExtra("arg_idContribucion", idContribucion);
                startActivity(intent_mg);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}