package edu.uoc.android.gfp.vistas.CuentaBancaria;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Periodicidad;
import edu.uoc.android.gfp.modeloDatos.T_tipo_Gasto;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.Bienvenida;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;

public class BusquedaCuentaBancaria extends AppCompatActivity implements View.OnClickListener {

    public String idUsuario;

    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtNumeroCuenta;
    private Button btnCancelar, btnBuscar;

    public MyApplication myApplication;


    //Variables necesarias para la búsdueda
    public String descripcion;
    public String numeroCuenta;



    @Override
    protected void onCreate (Bundle savedInstanceState)
    {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.busquedacuentabancaria);


        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("idUsuario");

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Buscar Números de Cuenta");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }



        myApplication = (MyApplication) getApplicationContext();

        //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
        final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


        //Inicialización de todos los elementos de la pantalla
        //con la información que se ha recuperado del gasto
        txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
        txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });


        txtNumeroCuenta = (EditText) findViewById(R.id.t_numero_cuenta);
        txtNumeroCuenta.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus)
                {
                    utilTecla.hideKeyBoard(v);
                }
            }
        });


        btnCancelar = (Button) findViewById(R.id.b_cancelar);
        btnBuscar = (Button) findViewById(R.id.b_buscar);

        // Metodos Listener
        btnCancelar.setOnClickListener((View.OnClickListener) this);
        btnBuscar.setOnClickListener((View.OnClickListener) this);

    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_buscar:

                //Se almacena en BD la info relativa al tipo de gasto
                //primero se debe validar si los campos están informados correctamente


                descripcion=txtDescripcion.getText().toString();
                numeroCuenta=txtNumeroCuenta.getText().toString();

                //Pasamos como argumentos todos los parámetros a la siguiente actividad
                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), DetalleCuentasBancarias.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                intent_mg.putExtra("arg_descripcion", descripcion);
                intent_mg.putExtra("arg_numeroCuenta",  numeroCuenta);

                startActivity(intent_mg);




                break;
            case R.id.b_cancelar:

                Intent intent = new Intent(this, Bienvenida.class);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

}