package edu.uoc.android.gfp.vistas.CuentaBancaria;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Cuenta_Bancaria;
import edu.uoc.android.gfp.modeloDatos.T_Ingreso;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaCuentaBancaria extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtDescripcion, txtNumeroCuenta;
    private Button btnModificar, btnEliminar;


    //Variables necesarias Ingreso
    public Integer idCuenta=0;
    public String descripcion;
    public String numeroCuenta;
    public String idUsuario;


    //Ingreso que recuperamos de la BD
    public T_Cuenta_Bancaria.Cuenta_Bancaria mcuenta;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichacuentabancaria);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idCuenta =getIntent().getExtras().getInt("arg_idCuenta");

            //Ojo para probar el formulario de modificación
            mcuenta= T_Cuenta_Bancaria.leerCuentaBancaria(idCuenta,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Detalle Ingreso");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del ingreso
            txtDescripcion = (TextView) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mcuenta.getdescripcion());

            txtNumeroCuenta = (TextView) findViewById(R.id.t_numero_cuenta);
            txtNumeroCuenta.setText(mcuenta.getnumeroCuenta().toString());

            btnEliminar = (Button) findViewById(R.id.b_eliminar);
            btnModificar = (Button) findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener((View.OnClickListener) this);
            btnModificar.setOnClickListener((View.OnClickListener) this);


        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaCuentaBancaria.class);
                intent.putExtra("idCuenta", idCuenta);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaCuentaBancaria.class);
                intent.putExtra("idCuenta", idCuenta);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}