package edu.uoc.android.gfp.vistas.CuentaBancaria;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.Bienvenida;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class RegistroCuentaBancaria extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtNumeroCuenta;

    private Button btnCancelar, btnGuardar;



    //Variables necesarias para registrar un Ingreso
    public String descripcion;
    public String numeroCuenta;
    public Integer idCuenta;
    public String idUsuario;


    //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
    public UtilidadesTeclado utilTecla;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.registrocuentabancaria);

            idUsuario= getIntent().getExtras().getString("idUsuario");

            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Alta Nueva Cuenta Bancaria");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            utilTecla = new UtilidadesTeclado(this);

            //Inicialización de todos los elementos de la pantalla

            txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtNumeroCuenta = (EditText) findViewById(R.id.t_numero_cuenta);
            txtNumeroCuenta.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);

            myApplication = (MyApplication) getApplicationContext();


    }


    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

             if (txtDescripcion.toString().isEmpty())
                    continua=false;

             if (txtNumeroCuenta.toString().isEmpty())
                    continua=false;

                if (continua==true)
                {


                    descripcion=txtDescripcion.getText().toString();
                    numeroCuenta=txtNumeroCuenta.getText().toString();


                    idCuenta=myApplication.altaCuentaBancaria(descripcion, numeroCuenta, idUsuario);

                    //Una vez se ha registadrado el gasto se redirige a la ficha del gasto
                    Intent intent_mg = new Intent(getApplicationContext(), FichaCuentaBancaria.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    intent_mg.putExtra("arg_idCuenta", idCuenta);
                    startActivity(intent_mg);


                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                Intent intent = new Intent(this, Bienvenida.class);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {

    }
}