package edu.uoc.android.gfp.vistas.Deseo;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.vistas.Bienvenida;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;

public class BajaDeseo extends AppCompatActivity {

    public String idUsuario;
    public Integer idDeseo;
    public MyApplication myApplication;


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.bajadeseo);

        myApplication = (MyApplication) getApplicationContext();

        //Obtenemos el usuario que ha hecho Login en la app
        idUsuario = getIntent().getExtras().getString("idUsuario");
        idDeseo = getIntent().getExtras().getInt("idDeseo");

        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Eliminar Deseo");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        //Antes de proceder al borrado del gasto pediremos al usuario la confirmación de la operacion
        AlertDialog.Builder confirmacionBorrado = new AlertDialog.Builder(this);

        confirmacionBorrado.setTitle("Eliminar Definitivamente Deseo");

        confirmacionBorrado.setMessage("¿Está seguro que desea eliminar el Deseo indicado?");

        confirmacionBorrado.setCancelable(false);

        confirmacionBorrado.setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                borrarDeseo();
            }
        });

        confirmacionBorrado.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface confirmacionBorrado, int id) {
                cancelar();
            }
        });

        confirmacionBorrado.show();

    }


    private void borrarDeseo()
    {

        myApplication.bajaDeseo(idDeseo);

        //Enviamos a la pantalla de Bienvenida , posible mejora a la pantalla anterior a la eliminación
        Intent intent = new Intent(this, Bienvenida.class);
        intent.putExtra("idUsuario", idUsuario);
        startActivity(intent);
    }

    private void cancelar()
    {
        //en el caso que el usuario no confirme la eliminación enviamos a la ficha del gasto, posible
        //mejora ir a la pantalla anterior a la eliminación
        Intent intent = new Intent(this, FichaDeseo.class);
        intent.putExtra("arg_idDeseo", idDeseo);
        intent.putExtra("arg_idUsuario", idUsuario);
        startActivity(intent);
    }

}