package edu.uoc.android.gfp.vistas;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.TextView;

import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.vistas.Contribucion.BusquedaContribucion;
import edu.uoc.android.gfp.vistas.Contribucion.RegistroContribucion;
import edu.uoc.android.gfp.vistas.CuentaBancaria.BusquedaCuentaBancaria;
import edu.uoc.android.gfp.vistas.CuentaBancaria.RegistroCuentaBancaria;
import edu.uoc.android.gfp.vistas.Deseo.BusquedaDeseo;
import edu.uoc.android.gfp.vistas.Deseo.RegistroDeseo;
import edu.uoc.android.gfp.vistas.Gasto.BusquedaGasto;
import edu.uoc.android.gfp.vistas.Gasto.RegistroGasto;
import edu.uoc.android.gfp.vistas.Ingreso.BusquedaIngreso;
import edu.uoc.android.gfp.vistas.Ingreso.RegistroIngreso;
import edu.uoc.android.gfp.vistas.Presupuesto.BusquedaPresupuesto;
import edu.uoc.android.gfp.vistas.Presupuesto.RegistroPresupuesto;
import edu.uoc.android.gfp.vistas.Situacion.FichaSituacion;
import edu.uoc.android.gfp.vistas.Situacion.RegistroSituacion;
import edu.uoc.android.gfp.vistas.TipoGasto.DetalleTipoGasto;
import edu.uoc.android.gfp.vistas.TipoGasto.RegistroTipoGasto;
import edu.uoc.android.gfp.vistas.TipoIngreso.DetalleTipoIngreso;
import edu.uoc.android.gfp.vistas.TipoIngreso.RegistroTipoIngreso;
import edu.uoc.android.gfp.vistas.usuario.FichaUsuario;


public class FragmentoCabecera extends Fragment {

    public static final String arg_idUsuario="idUsuario";
    public static final String arg_funcionalidad="funcionalidad";

    private String idUsuario;
    private String funcionalidad;

    private ImageView b_menu_app;


    public FragmentoCabecera() {

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);


        if (getArguments().containsKey(arg_idUsuario) &&  getArguments().containsKey(arg_funcionalidad))
        {
            //Si los parámetros existen se incializan las propiedades de la cabecera
            idUsuario= getArguments().getString(arg_idUsuario);
            funcionalidad=getArguments().getString(arg_funcionalidad);

        }

        Activity activity = this.getActivity();

        setHasOptionsMenu(true);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.cabecera, container, false);

        ((TextView) rootView.findViewById(R.id.l_dondeEstoy)).setText(funcionalidad);


        registerForContextMenu(rootView.findViewById(R.id.b_menuPrincipal));
        registerForContextMenu(rootView.findViewById(R.id.b_mantenimiento));
        registerForContextMenu(rootView.findViewById(R.id.b_cierreSesion));
        registerForContextMenu(rootView.findViewById(R.id.b_casa));
        return rootView;
    }

    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenu.ContextMenuInfo menuInfo) {


        super.onCreateContextMenu(menu, v, menuInfo);

        // Creamos el objeto que debe inflar la vista del menú en la pantalla.
        MenuInflater inflater = new MenuInflater(getContext());


        switch (v.getId()) {
            case R.id.b_menuPrincipal:
                // Se ha realizado pulsación larga sobre el botón 1.
                // Inflamos el menú pasando la referencia al menú que queremos
                // mostrar y el objeto ContextMenu que recibimos como parámetro.
                inflater.inflate(R.menu.menu, menu);
                break;

            case R.id.b_mantenimiento:
                // Se ha realizado pulsación larga sobre el botón de mantenimiento.
                // Inflamos el menú pasando la referencia al menú que queremos
                // mostrar y el objeto ContextMenu que recibimos como parámetro.
                inflater.inflate(R.menu.menu_configuracion, menu);
                break;

            case R.id.b_cierreSesion:
                // Enviamos a la pantalla de cierre de session de la aplicación
                Intent intent_cs = new Intent(getContext(), CierreSesion.class);
                intent_cs.putExtra("idUsuario", idUsuario);
                startActivity(intent_cs);
                break;
            case R.id.b_casa:
                // Enviamos a la pantalla de Bienvenida de la aplicación
                Intent intent_ba = new Intent(getContext(), Bienvenida.class);
                intent_ba.putExtra("idUsuario", idUsuario);
                startActivity(intent_ba);
                break;
        }

    }
/*
    //Opciones de menú
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenu.ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);
        MenuInflater inflater = new MenuInflater(getContext());
        inflater.inflate(R.menu.menu,menu);
    }

*/

    @Override
    public boolean onContextItemSelected(MenuItem item) {

        AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item.getMenuInfo();

        switch (item.getItemId()) {
            case R.id.m_a_gastos:
                //Opción de alta de gastos
                Intent intent_rg = new Intent(getContext(), RegistroGasto.class);
                intent_rg.putExtra("idUsuario", idUsuario);
                startActivity(intent_rg);
                break;
            /*
            Opciones que pasan a estar accesibles desde el listado resultado de la búsqueda
                case R.id.m_e_gastos:
               //Opción de eliminar gastos
                Intent intent_eg = new Intent(getContext(), BajaGasto.class);
                intent_eg.putExtra("idUsuario", idUsuario);
                startActivity(intent_eg);
                break;
            case R.id.m_m_gastos:
                //Opción de modificar gastos
                Intent intent_mg = new Intent(getContext(), ModificaGasto.class);
                intent_mg.putExtra("idUsuario", idUsuario);
                intent_mg.putExtra("idGasto", 4);
                startActivity(intent_mg);
                break;
            */
            case R.id.m_b_gastos:
                //Opción de buscar gastos
                Intent intent_bg = new Intent(getContext(), BusquedaGasto.class);
                intent_bg.putExtra("idUsuario", idUsuario);
                startActivity(intent_bg);
                break;
            case R.id.m_a_ingresos:
                //Opción de alta de ingresos
                Intent intent_ri = new Intent(getContext(), RegistroIngreso.class);
                intent_ri.putExtra("idUsuario", idUsuario);
                startActivity(intent_ri);
                break;
           /*
            Opciones que pasan a estar accesibles desde el listado resultado de la búsqueda
            case R.id.m_e_ingresos:
                //Opción de eliminar ingresos
                Intent intent_ei = new Intent(getContext(), BajaIngreso.class);
                intent_ei.putExtra("idUsuario", idUsuario);
                intent_ei.putExtra("idIngreso", 2);
                startActivity(intent_ei);
                break;
            case R.id.m_m_ingresos:
                //Opción de modificar ingresos
                Intent intent_mi = new Intent(getContext(), ModificaIngreso.class);
                intent_mi.putExtra("idUsuario", idUsuario);
                intent_mi.putExtra("idIngreso", 2);
                startActivity(intent_mi);
                break;
            */
            case R.id.m_b_ingresos:
                //Opción de buscar ingresos
                Intent intent_bi = new Intent(getContext(), BusquedaIngreso.class);
                intent_bi.putExtra("idUsuario", idUsuario);
                startActivity(intent_bi);
                break;
            case R.id.m_a_deseos:
                //Opción de alta de deseos
                Intent intent_rd = new Intent(getContext(), RegistroDeseo.class);
                intent_rd.putExtra("idUsuario", idUsuario);
                startActivity(intent_rd);
                break;
                /*
            Opciones que pasan a estar accesibles desde el listado resultado de la búsqueda
            case R.id.m_e_deseos:
                //Opción de eliminar deseos
                Intent intent_ed = new Intent(getContext(), BajaDeseo.class);
                intent_ed.putExtra("idUsuario", idUsuario);
                startActivity(intent_ed);
                break;
            case R.id.m_m_deseos:
                //Opción de modificar deseos
                Intent intent_md = new Intent(getContext(), ModificaDeseo.class);
                intent_md.putExtra("idUsuario", idUsuario);
                startActivity(intent_md);
                break;
                */
            case R.id.m_b_deseos:
                //Opción de buscar deseos
                Intent intent_bd = new Intent(getContext(), BusquedaDeseo.class);
                intent_bd.putExtra("idUsuario", idUsuario);
                startActivity(intent_bd);
                break;
            case R.id.m_a_presupuestos:
                //Opción de alta de presupuestos
                Intent intent_rp = new Intent(getContext(), RegistroPresupuesto.class);
                intent_rp.putExtra("idUsuario", idUsuario);
                startActivity(intent_rp);
                break;
                /*
            Opciones que pasan a estar accesibles desde el listado resultado de la búsqueda
            case R.id.m_e_presupuestos:
                //Opción de eliminar presupuestos
                Intent intent_ep = new Intent(getContext(), BajaPresupuesto.class);
                intent_ep.putExtra("idUsuario", idUsuario);
                startActivity(intent_ep);
                break;
            case R.id.m_m_presupuestos:
                //Opción de modificar gastos
                //Se ha escogido la opción de presupuestos
                Intent intent_mp = new Intent(getContext(), ModificaPresupuesto.class);
                intent_mp.putExtra("idUsuario", idUsuario);
                startActivity(intent_mp);
                break;
                */
            case R.id.m_b_presupuestos:
                //Opción de buscar presupuestos
                Intent intent_bp = new Intent(getContext(), BusquedaPresupuesto.class);
                intent_bp.putExtra("idUsuario", idUsuario);
                startActivity(intent_bp);
                break;

            case R.id.m_b_contribuciones:
                //Opción de buscar contribuciones
                Intent intent_bc = new Intent(getContext(), BusquedaContribucion.class);
                intent_bc.putExtra("idUsuario", idUsuario);
                startActivity(intent_bc);
                break;
            case R.id.m_a_contribuciones:
                //Opción de alta de contribuciones
                Intent intent_rc = new Intent(getContext(), RegistroContribucion.class);
                intent_rc.putExtra("idUsuario", idUsuario);
                startActivity(intent_rc);
                break;
            case R.id.m_usuario:

                Intent intent_fp = new Intent(getContext(), FichaUsuario.class);
                intent_fp.putExtra("arg_idUsuario", idUsuario);
                intent_fp.putExtra("arg_codUsuario", 0);
                startActivity(intent_fp);
                break;
            case R.id.m_a_tipo_gasto:

                Intent intent_atg = new Intent(getContext(), RegistroTipoGasto.class);
                intent_atg.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_atg);
                break;
            case R.id.m_b_tipo_gasto:

                Intent intent_btg = new Intent(getContext(), DetalleTipoGasto.class);
                intent_btg.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_btg);
                break;
            case R.id.m_a_tipo_ingreso:

                Intent intent_ati = new Intent(getContext(), RegistroTipoIngreso.class);
                intent_ati.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_ati);
                break;
            case R.id.m_b_tipo_ingreso:

                Intent intent_bti = new Intent(getContext(), DetalleTipoIngreso.class);
                intent_bti.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_bti);
                break;
            case R.id.m_situacion:

                Intent intent_sit = new Intent(getContext(), RegistroSituacion.class);
                intent_sit.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_sit);
                break;
            case R.id.m_a_cuentasbancarias:

                Intent intent_acb = new Intent(getContext(), RegistroCuentaBancaria.class);
                intent_acb.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_acb);
                break;
            case R.id.m_b_cuentasbancarias:

                Intent intent_mcb = new Intent(getContext(), BusquedaCuentaBancaria.class);
                intent_mcb.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_mcb);
                break;
        }
        return true;
    }

}


