package edu.uoc.android.gfp.vistas.Presupuesto;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.Bienvenida;
import edu.uoc.android.gfp.vistas.Deseo.RegistroDeseo;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;
import edu.uoc.android.gfp.utilidades.UtilidadesFecha;


public class RegistroPresupuesto extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion, txtImporte, txtdFecha, txthFecha;

    private Button btnCancelar, btnGuardar;


    //Variables necesarias para registrar un Presupuesto
    public String descripcion;
    public float importe;
    public String desdeFecha,hastaFecha;
    public String idUsuario;
    public Integer idPresupuesto;

    //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
    public UtilidadesTeclado utilTecla;
    public UtilidadesFecha utilFecha;


    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState)
        {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.registropresupuesto);

            myApplication = (MyApplication) getApplicationContext();

            idUsuario= getIntent().getExtras().getString("idUsuario");

            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Alta Nuevo Presupuesto");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


            //Inicialización de todos los elementos de la pantalla

            txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtImporte = (EditText) findViewById(R.id.t_importe);
            txtImporte.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtdFecha = (EditText) findViewById(R.id.t_dfecha);
            txtdFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        if (!txtdFecha.getText().toString().isEmpty())
                        {
                            if (!utilFecha.validarFecha(txtdFecha.getText().toString())) {
                                //La validación de la fecha no ha sido correcta
                                //mostramos mensaje
                                Toast.makeText(RegistroPresupuesto.this, "Formato de fecha incorrecto mm/dd/yyyy", Toast.LENGTH_SHORT).show();

                            }
                        }
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txthFecha = (EditText) findViewById(R.id.t_hfecha);
            txthFecha.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        if (!txthFecha.getText().toString().isEmpty())
                        {
                            if (!utilFecha.validarFecha(txthFecha.getText().toString())) {
                                //La validación de la fecha no ha sido correcta
                                //mostramos mensaje
                                Toast.makeText(RegistroPresupuesto.this, "Formato de fecha incorrecto mm/dd/yyyy", Toast.LENGTH_SHORT).show();

                            }
                        }
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);



        }



    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

             if (txtDescripcion.toString().isEmpty())
                    continua=false;

                if (txtImporte.getText().toString().isEmpty())
                    continua=false;

                if (txtdFecha.getText().toString().isEmpty())
                    continua=false;

                if (txthFecha.getText().toString().isEmpty())
                    continua=false;


                if (continua==true)
                {


                    descripcion=txtDescripcion.getText().toString();
                    //el valor ya está asignado idTipoGasto
                    importe= Float.parseFloat(txtImporte.getText().toString());

                    desdeFecha=utilFecha.formatearFecha(txtdFecha.getText().toString());
                    hastaFecha=utilFecha.formatearFecha(txthFecha.getText().toString());


                    idPresupuesto=myApplication.altaPresupuesto(descripcion, importe, desdeFecha,hastaFecha, idUsuario);

                    //Una vez se ha registadrado el gasto se redirige a la ficha del presupuesto
                    Intent intent_mg = new Intent(getApplicationContext(), FichaPresupuesto.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    intent_mg.putExtra("arg_idPresupuesto", idPresupuesto);
                    startActivity(intent_mg);


                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Se vuelve a la pantalla de Bienvenida
                Intent intent = new Intent(this, Bienvenida.class);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {

    }
}