package edu.uoc.android.gfp.vistas.TipoGasto;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.utilidades.UtilidadesDesplegable;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;
import edu.uoc.android.gfp.modeloDatos.T_tipo_Gasto;


public class ModificaTipoGasto extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtDescripcion;
    private Button btnCancelar, btnGuardar;
    private Spinner despNecesidad;


    //Variables necesarias para modificar un ingreso
    public Integer idTipoGasto=0;
    public String descripcion;
    public Integer idNecesidad=-1;
    public String necesidad;

    public String idUsuario;

    //Tipo Gasto que recuperamos de la BD
    public T_tipo_Gasto.Tipo_Gasto mtipogasto;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.modificatipogasto);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            idTipoGasto =getIntent().getExtras().getInt("arg_idTipoGasto");

            //Ojo para probar el formulario de modificación
            mtipogasto= T_tipo_Gasto.leerTipoGasto(idTipoGasto);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Modifica Tipo Gasto");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del deseo
            txtDescripcion = (EditText) findViewById(R.id.t_descripcion);
            txtDescripcion.setText(mtipogasto.getdescripcion());
            txtDescripcion.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);


            despNecesidad = (Spinner) findViewById(R.id.t_necesidad);


            // Carga desplegable de tipo Gasto
        despNecesidad.setAdapter((ArrayAdapter<String>) myApplication.cargaNecesidad());

            Integer indice = UtilidadesDesplegable.getIndex(despNecesidad,mtipogasto.getNecesidad());

            despNecesidad.setSelection(indice);


            despNecesidad.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

                @Override
                public void onItemSelected(AdapterView<?> arg0, View arg1,
                                           int pos, long id) {

                    String descripcion = arg0.getItemAtPosition(pos)
                            .toString();

                    if (descripcion.equals(getResources().getString(R.string.ini_spinner))) {
                        //No se entiende seleccionado ningún valor
                        idNecesidad = -1;
                        necesidad="";
                    } else {

                        idNecesidad = T_tipo_Gasto.ultimoIdTipoGasto();
                        necesidad=descripcion;


                    }

                }

                @Override
                public void onNothingSelected(AdapterView<?> arg0) {
                    // TODO Auto-generated method stub

                }
            });

    }




    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

                //Se almacena en BD la info relativa al tipo de gasto
                //primero se debe validar si los campos están informados correctamente


                if (txtDescripcion.getText().toString().isEmpty())
                    continua=false;

                if (idNecesidad==-1)
                    continua=false;



                if (continua==true)
                {
                    descripcion=txtDescripcion.getText().toString();
                    myApplication.modificaTipoGasto (idTipoGasto,descripcion,idNecesidad,necesidad);
                    //Envio de nuevo a la ficha del gasto
                    Intent intent_mg = new Intent(getApplicationContext(), DetalleTipoGasto.class);
                    intent_mg.putExtra("arg_idUsuario", idUsuario);
                    startActivity(intent_mg);

                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), DetalleTipoGasto.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent_mg);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}