package edu.uoc.android.gfp.vistas.TipoIngreso;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Gasto;
import edu.uoc.android.gfp.modeloDatos.T_tipo_Ingreso;
import edu.uoc.android.gfp.utilidades.UtilidadesConstantes;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;

public class DetalleTipoIngreso extends AppCompatActivity {


    private SimpleItemRecyclerViewAdapter adapter;
    private RecyclerView recyclerView;

    public String descripcion;



    //Parámetros de la actividad
    public String idUsuario;

    UtilidadesConstantes constantes = new UtilidadesConstantes();

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.detalletipoingreso);

        idUsuario= getIntent().getExtras().getString("arg_idUsuario");



        if (savedInstanceState == null) {
            //Fragmento para incluir la cabecera
            Bundle arguments = new Bundle();
            arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
            arguments.putString(FragmentoCabecera.arg_funcionalidad, "Resultado Ingresos");
            FragmentoCabecera fragment = new FragmentoCabecera();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.frame_cabecera, fragment)
                    .commit();
        }

        recyclerView = findViewById(R.id.lista_detalle);
        RecyclerView.LayoutManager layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);

        setupRecyclerView(recyclerView);

        List<T_tipo_Ingreso.Tipo_Ingreso> DETALLES_TIPO_INGRESO = new ArrayList<>();

        DETALLES_TIPO_INGRESO=T_tipo_Ingreso.obtenerDetalleTiposIngresos(getApplicationContext());

        adapter.setItems(DETALLES_TIPO_INGRESO);
    }



    private void setupRecyclerView(@NonNull RecyclerView recyclerView)
    {
            adapter = new SimpleItemRecyclerViewAdapter(new ArrayList<T_tipo_Ingreso.Tipo_Ingreso>());
            recyclerView.setAdapter(adapter);
    }

    public class SimpleItemRecyclerViewAdapter extends RecyclerView.Adapter<SimpleItemRecyclerViewAdapter.ViewHolder>
    {

            private List<T_tipo_Ingreso.Tipo_Ingreso> mValues;

            public SimpleItemRecyclerViewAdapter(ArrayList<T_tipo_Ingreso.Tipo_Ingreso> items)
            {
                mValues = items;
            }



            public void setItems(List<T_tipo_Ingreso.Tipo_Ingreso> items) {
                    mValues = items;
            }

            @Override
            public int getItemViewType(int position) {
                int type;

                if (position % 2 == 0) {
                    type = 0;
                } else {
                    type = 1;
                }
                return type;
            }

            @Override
            public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType)
            {
                View view = null;

                view = LayoutInflater.from(parent.getContext())
                            .inflate(R.layout.frag_listado_detalle_gastos, parent, false);

                if (viewType==0)
                    view.setBackgroundColor(R.color.colorListadoPar);
                else
                    view.setBackgroundColor(R.color.colorListadoImpar);

                return new ViewHolder(view);
            }

            @Override
            public void onBindViewHolder(final ViewHolder holder, final int position)
            {

                holder.t_caracteristica.setText("");
                holder.t_id_operacion.setText(String.valueOf(mValues.get(position).getidTipoIngreso()));
                holder.t_importe.setText("");
                holder.t_descripcion.setText(mValues.get(position).descripcion);
                holder.t_fecha.setText("");

                holder.mView.setTag(mValues.get(position).getidTipoIngreso());

                holder.mView.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {

                        String aux;
                        Integer idTipoIngreso;


                        aux = v.getTag().toString();
                        idTipoIngreso=Integer.parseInt(aux);

                        Context context = v.getContext();

                        Intent intent;
                        intent = new Intent(context, ModificaTipoIngreso.class);
                        //FALTA revisar el valor de los parámetros

                        intent.putExtra("arg_idTipoIngreso", idTipoIngreso);
                        intent.putExtra("arg_idUsuario", idUsuario);
                        startActivity(intent);

                    }
                });
            }

            @Override
            public int getItemCount() {
                return mValues.size();
            }

            public class ViewHolder extends RecyclerView.ViewHolder
            {
                public final View mView;
                public TextView t_id_operacion=null;
                public TextView t_descripcion=null;
                public TextView t_caracteristica=null;
                public ImageView img_operacion=null;
                public TextView t_importe=null;
                public TextView t_fecha=null;
                public T_Gasto.Gasto mItem;

                public ViewHolder(View view) {
                    super(view);
                    mView = view;
                    t_id_operacion = view.findViewById(R.id.t_id_operacion);
                    t_descripcion = view.findViewById(R.id.t_descripcion);
                    t_caracteristica = view.findViewById(R.id.t_caracteristicas);
                    img_operacion = view.findViewById(R.id.img_operacion);
                    t_importe = view.findViewById(R.id.t_importe);
                    t_fecha = view.findViewById(R.id.t_fecha);

                }

                @Override
                public String toString() {
                    return super.toString() + " '" + t_descripcion.getText() + "'";
                }
            }
        }
    }
