package edu.uoc.android.gfp.vistas.usuario;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Usuario;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class FichaUsuario extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private TextView txtNombreCompleto,txtIdUsuario,txtPassword,txtEmail;
    private TextView despAlimentacion;
    private TextView checkNotificarEmail;

    private Button btnEliminar, btnModificar;




    //Variables necesarias para registrar un Ingreso
    public Integer codUsuario=-1;
    public String idUsuario;



    //Usuario que recuperamos de la BD
    public T_Usuario.Usuario musuario;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.fichausuario);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            codUsuario =getIntent().getExtras().getInt("arg_codUsuario");


            musuario= T_Usuario.leerUsuario(codUsuario,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Ficha Usuario");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }


            //Inicialización de todos los elementos de la pantalla
            //con la información que se ha recuperado del ingreso
            txtNombreCompleto = (TextView) findViewById(R.id.t_nombre_completo);
            txtNombreCompleto.setText(musuario.getnombreCompleto());

            txtIdUsuario = (TextView) findViewById(R.id.t_idusuario);
            txtIdUsuario.setText(musuario.getidUsuario().toString());

            txtPassword = (TextView) findViewById(R.id.t_password);
            txtPassword.setText(musuario.getpwd());

            txtEmail = (TextView) findViewById(R.id.t_email);
            txtEmail.setText(musuario.getemail());

            despAlimentacion = (TextView) findViewById(R.id.desp_alimentacion);
            despAlimentacion.setText(musuario.getalimentacion());

            checkNotificarEmail = (TextView) findViewById(R.id.c_notificar_email);
            checkNotificarEmail.setText("Notifica vía email: " +  musuario.getNotificarEmail());

            btnEliminar = (Button) findViewById(R.id.b_eliminar);
            btnModificar = (Button) findViewById(R.id.b_modificar);

            // Metodos Listener
            btnEliminar.setOnClickListener((View.OnClickListener) this);
            btnModificar.setOnClickListener((View.OnClickListener) this);


        }


    @Override
    public void onClick (View v){

        Intent intent=null;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_modificar:

                intent = new Intent(this, ModificaUsuario.class);
                intent.putExtra("arg_codUsuario", codUsuario);
                intent.putExtra("arg_idUsuario", idUsuario);
                startActivity(intent);

                break;
            case R.id.b_eliminar:
                //Se cancela el formulario se resetea.

                intent = new Intent(this, BajaUsuario.class);
                intent.putExtra("codUsuario", codUsuario);
                intent.putExtra("idUsuario", idUsuario);
                startActivity(intent);

                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}