package edu.uoc.android.gfp.vistas.usuario;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;


import edu.uoc.android.gfp.MyApplication;
import edu.uoc.android.gfp.R;
import edu.uoc.android.gfp.modeloDatos.T_Usuario;
import edu.uoc.android.gfp.utilidades.UtilidadesDesplegable;
import edu.uoc.android.gfp.utilidades.UtilidadesTeclado;
import edu.uoc.android.gfp.vistas.FragmentoCabecera;


public class ModificaUsuario extends AppCompatActivity implements View.OnClickListener {


    // Variables de los elementos de la pantalla
    private EditText txtNombreCompleto,txtIdUsuario,txtPassword,txtEmail;
    private Spinner despAlimentacion;
    private CheckBox checkNotificarEmail;

    private Button btnCancelar, btnGuardar;



    //Variables necesarias para registrar un Ingreso
    public String nombreCompleto;
    public Integer codUsuario=-1;
    public String idUsuario;
    public String password;
    public String email;
    public String notificarEmail;
    public Integer idAlimentacion;
    public String alimentacion;


    //Usuario que recuperamos de la BD
    public T_Usuario.Usuario musuario;

    public MyApplication myApplication;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        {

            super.onCreate(savedInstanceState);
            setContentView(R.layout.modificausuario);

            myApplication = (MyApplication) getApplicationContext();

            //Parámetros que recibimos para el fragmento
            idUsuario= getIntent().getExtras().getString("arg_idUsuario");
            codUsuario =getIntent().getExtras().getInt("arg_codUsuario");


            musuario= T_Usuario.leerUsuario(codUsuario,idUsuario);

            //Cargamos la cabecera de la aplicación
            if (savedInstanceState == null) {
                //Fragmento para incluir la cabecera
                Bundle arguments = new Bundle();
                arguments.putString(FragmentoCabecera.arg_idUsuario, idUsuario);
                arguments.putString(FragmentoCabecera.arg_funcionalidad, "Modifica Perfil");
                FragmentoCabecera fragment = new FragmentoCabecera();
                fragment.setArguments(arguments);
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.frame_cabecera, fragment)
                        .commit();
            }

            //Para la gestión de ocultar el teclado una vez que un campo de texto pierde el foco
            final UtilidadesTeclado utilTecla = new UtilidadesTeclado(this);


            txtNombreCompleto = (EditText) findViewById(R.id.t_nombre_completo);
            txtNombreCompleto.setText(musuario.getnombreCompleto());
            txtNombreCompleto.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            txtIdUsuario = (EditText) findViewById(R.id.t_idusuario);
            txtIdUsuario.setText(musuario.getidUsuario().toString());
            txtIdUsuario.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtPassword = (EditText) findViewById(R.id.t_password);
            txtPassword.setText(musuario.getpwd());
            txtPassword.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });

            txtEmail = (EditText) findViewById(R.id.t_email);
            txtEmail.setText(musuario.getemail());
            txtEmail.setOnFocusChangeListener(new View.OnFocusChangeListener() {
                @Override
                public void onFocusChange(View v, boolean hasFocus) {
                    if(!hasFocus)
                    {
                        utilTecla.hideKeyBoard(v);
                    }
                }
            });


            btnCancelar = (Button) findViewById(R.id.b_cancelar);
            btnGuardar = (Button) findViewById(R.id.b_guardar);

            // Metodos Listener
            btnCancelar.setOnClickListener((View.OnClickListener) this);
            btnGuardar.setOnClickListener((View.OnClickListener) this);


            checkNotificarEmail = (CheckBox) findViewById(R.id.c_notificar_email);
            if (musuario.getNotificarEmail().equals("S"))
             checkNotificarEmail.setChecked(true);

            despAlimentacion = (Spinner) findViewById(R.id.desp_alimentacion);

            myApplication = (MyApplication) getApplicationContext();


            // Carga desplegable de tipo Gasto
            despAlimentacion.setAdapter((ArrayAdapter<String>) myApplication.cargaAlimentacion());

            Integer indice = UtilidadesDesplegable.getIndex(despAlimentacion,musuario.getalimentacion());

            despAlimentacion.setSelection(indice);

            despAlimentacion.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

                @Override
                public void onItemSelected(AdapterView<?> arg0, View arg1,
                                           int pos, long id) {

                    String descripcion = arg0.getItemAtPosition(pos)
                            .toString();

                    if (descripcion.equals(getResources().getString(R.string.ini_spinner))) {
                        //No se entiende seleccionado ningún valor
                        alimentacion="";
                        idAlimentacion = -1;
                    } else {
                        alimentacion=descripcion;
                        idAlimentacion = pos;
                    }

                }

                @Override
                public void onNothingSelected(AdapterView<?> arg0) {
                    // TODO Auto-generated method stub

                }
            });

        }


    }




    @Override
    public void onClick (View v){

        Boolean continua;

        continua=true;

        // Dependiendo si se pulsa Login o Registro ejecuta una actividad u otra
        switch (v.getId()) {
            case R.id.b_guardar:

                if (txtNombreCompleto.toString().isEmpty())
                    continua=false;

                if (txtIdUsuario.getText().toString().isEmpty())
                    continua=false;

                if (txtPassword.getText().toString().isEmpty())
                    continua=false;

                if (txtPassword.getText().toString().isEmpty())
                    continua=false;

                if (idAlimentacion==-1)
                    continua=false;

                if (continua==true)
                {


                    nombreCompleto=txtNombreCompleto.getText().toString();
                    idUsuario=txtIdUsuario.getText().toString();
                    password=txtPassword.getText().toString();
                    email=txtEmail.getText().toString();

                    if (checkNotificarEmail.isChecked())
                        notificarEmail="S";
                    else
                        notificarEmail="N";

                   myApplication.modificaUsuario(musuario.getCodUsuario(),idUsuario,password,nombreCompleto,email,idAlimentacion,alimentacion,notificarEmail);

                    Intent intent = new Intent(this, FichaUsuario.class);
                    intent.putExtra("arg_codUsuario", codUsuario);
                    intent.putExtra("arg_idUsuario", idUsuario);
                    startActivity(intent);


                }
                else
                {
                    Toast toast1 = Toast.makeText(getApplicationContext(), "Existen campos vacios. Revise el formulario", Toast.LENGTH_SHORT);
                    toast1.setGravity(Gravity.CENTER,0,0);
                    toast1.show();
                }
                break;
            case R.id.b_cancelar:

                //Envio de nuevo a la ficha del gasto
                Intent intent_mg = new Intent(getApplicationContext(), FichaUsuario.class);
                intent_mg.putExtra("arg_idUsuario", idUsuario);
                intent_mg.putExtra("arg_codUsuario", codUsuario);
                startActivity(intent_mg);


                break;
            default:
                break;

        }
    }

    public void limpiarCampos()
    {
        //para limpliar
    }
}